--APBP - Attendance Percentage by Period - Custom View - Aeries Software - Jared Kuszewski
--Create APBP Custom View if not present - Run line 4 if you wish to drop a prior APBP rendition before I added version control
/* 
drop view APBP; delete from ctf where tc = 'APBP'; delete from ctd where tc = 'APBP';
*/
declare @version varchar(23) = '2022-09-26 16:45:00.000'
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'APBP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > --your version here
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'APBP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale APBP view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''APBP''and o.[type_desc] = ''VIEW'') begin drop view APBP end; delete from ctf where tc = ''APBP''; delete from ctd where tc = ''APBP'';'
exec (@DynaQuery)
set @DynaQuery = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@DynaQuery)
set @DynaQuery = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@DynaQuery)
set @DynaQuery = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@DynaQuery)


set @DynaQuery = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))

update apds set jod = getdate()
update apds set jod = getdate()
'
EXEC (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
--APBP (Attendance Percentage by Period) custom view - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
CREATE VIEW APBP AS

WITH D 
(SC, DY, DT, HO, MO, BL, AB, DW, BL0, BL1, BL2, BL3, BL4, BL5, BL6, BL7, BL8, BL9)
as 
(
SELECT SC, DY, DT, HO, MO, BL, AB,
DATEPART(DW,DT) DW, 
CASE WHEN LEFT(BL,1) = ''0'' THEN 1 ELSE 0 END BL0,
CASE WHEN SUBSTRING(BL,2,1) = ''1'' THEN 1 ELSE 0 END BL1,
CASE WHEN SUBSTRING(BL,3,1) = ''2'' THEN 1 ELSE 0 END BL2,
CASE WHEN SUBSTRING(BL,4,1) = ''3'' THEN 1 ELSE 0 END BL3,
CASE WHEN SUBSTRING(BL,5,1) = ''4'' THEN 1 ELSE 0 END BL4,
CASE WHEN SUBSTRING(BL,6,1) = ''5'' THEN 1 ELSE 0 END BL5,
CASE WHEN SUBSTRING(BL,7,1) = ''6'' THEN 1 ELSE 0 END BL6,
CASE WHEN SUBSTRING(BL,8,1) = ''7'' THEN 1 ELSE 0 END BL7,
CASE WHEN SUBSTRING(BL,9,1) = ''8'' THEN 1 ELSE 0 END BL8,
CASE WHEN SUBSTRING(BL,10,1) = ''9'' THEN 1 ELSE 0 END BL9
FROM [DAY] WHERE DEL = 0
)

SELECT 
COUNTS.SC, 
COUNTS.SN, 
1 SQ,
CONVERT(VARCHAR(10),MIN(COUNTS.DT),101) DS, 
CONVERT(VARCHAR(10),MAX(COUNTS.DT),101) DE, 
COUNTS.SE, 
MST.SM,
MST.PD,
CRS.CO, 
TCH.TE,
MST.DY,
CRS.S1,
CRS.DC,
SUM(EnrolledInCAR) EIC, 
SUM(DaysAbsent) DAB, 
SUM(DaysTardy) DTY, 
SUM(TempNotEnrolled) TNE,
LEFT(100 - cast(SUM(DaysAbsent) as dec(12,4))/(SUM(EnrolledInCAR) - SUM(TempNotEnrolled))*100,6) PRS, --PresentPercent
LEFT(100 -  cast(SUM(DaysTardy) as dec(12,4))/(SUM(EnrolledInCAR) - SUM(DaysAbsent) - SUM(TempNotEnrolled))*100,6) PNC, --PunctualPercent
0 DEL,
CURRENT_TIMESTAMP DTS
FROM (

SELECT distinct
C.SC, C.SN, D.DT, M.SE
,1 EnrolledInCAR
,isnull((select A from(
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 0 and a0 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 1 and a1 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 2 and a2 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 3 and a3 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 4 and a4 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 5 and a5 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 6 and a6 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 7 and a7 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 8 and a8 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 9 and a9 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc))) p)
,0) DaysAbsent
,isnull((select A from(
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 0 and a0 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 1 and a1 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 2 and a2 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 3 and a3 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 4 and a4 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 5 and a5 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 6 and a6 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 7 and a7 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 8 and a8 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 9 and a9 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc))) p)
,0) DaysTardy
,isnull((select A from(
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 0 and a0 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 1 and a1 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 2 and a2 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 3 and a3 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 4 and a4 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 5 and a5 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 6 and a6 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 7 and a7 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 8 and a8 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 9 and a9 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc))) p)
,0) TempNotEnrolled

FROM
LOC L INNER JOIN CAR C ON L.CD = C.SC
INNER JOIN D ON D.SC = C.SC
INNER JOIN MST M ON C.SC = M.SC AND C.SE = M.SE
LEFT JOIN APDS ON C.SC = APDS.SC AND C.SN = APDS.SN
WHERE C.DEL = 0 and D.DT >= C.DS AND (D.DT <= C.DE OR C.DE IS NULL)
AND D.DT BETWEEN COALESCE(APDS.SWH,''1/1/1900'') AND COALESCE(APDS.TWH,''12/31/9999'')
AND D.HO NOT IN (''@'',''#'',''$'')
AND L.K < 1 --NoTracks
AND D.DT < CURRENT_TIMESTAMP --Do not count the future
AND 1 =
CASE WHEN
CASE 
WHEN L.AB = 1 AND M.DY = ''A-DAYS'' AND D.AB = ''A'' THEN 1
WHEN L.AB = 1 AND M.DY = ''B-DAYS'' AND D.AB = ''B'' THEN 1
WHEN M.PD = 0 AND D.BL0 = 1 THEN 1
WHEN M.PD = 1 AND D.BL1 = 1 THEN 1
WHEN M.PD = 2 AND D.BL2 = 1 THEN 1
WHEN M.PD = 3 AND D.BL3 = 1 THEN 1
WHEN M.PD = 4 AND D.BL4 = 1 THEN 1
WHEN M.PD = 5 AND D.BL5 = 1 THEN 1
WHEN M.PD = 6 AND D.BL6 = 1 THEN 1
WHEN M.PD = 7 AND D.BL7 = 1 THEN 1
WHEN M.PD = 8 AND D.BL8 = 1 THEN 1
WHEN M.PD = 9 AND D.BL9 = 1 THEN 1
WHEN D.BL = '''' THEN 1
ELSE 0 
END = 1 
AND
CASE 
WHEN D.DW = 2 AND M.MM = 1 THEN 1
WHEN D.DW = 3 AND M.MT = 1 THEN 1
WHEN D.DW = 4 AND M.MW = 1 THEN 1
WHEN D.DW = 5 AND M.MR = 1 THEN 1
WHEN D.DW = 6 AND M.MF = 1 THEN 1
ELSE 0 
END = 1
AND 
CASE WHEN
C.SN IN (SELECT SN FROM ENR WHERE SC = C.SC AND SN = C.SN AND DEL = 0 
AND RIGHT(YR,2) = SUBSTRING(DB_NAME(),4,2) 
AND D.DT >= C.DS AND (D.DT <= C.DE OR C.DE IS NULL))
THEN 1 
ELSE 0
END = 1
THEN 1
ELSE 0
END 

) COUNTS
INNER JOIN MST ON COUNTS.SC = MST.SC AND COUNTS.SE = MST.SE
INNER JOIN TCH ON MST.SC = TCH.SC AND MST.TN = TCH.TN
INNER JOIN CRS ON MST.CN = CRS.CN

GROUP BY COUNTS.SC, COUNTS.SN, COUNTS.SE, MST.SM, MST.PD, CRS.CO, TCH.TE, MST.DY, CRS.S1, CRS.DC
HAVING (SUM(EnrolledInCAR) - SUM(DaysAbsent) - SUM(TempNotEnrolled)) > 0
AND (SUM(EnrolledInCAR) - SUM(TempNotEnrolled)) > 0
'
exec (@DynaQuery)

INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'APBP', N'Attendance Percentage by Period', N'Student Data', N'SC,SN,SQ', N'STU', N'SC,SN', N'SC,SN', N'Many', N'SC,SN,PD,DS', 0, CAST(N'2018-10-04T13:22:37.670' AS DateTime), 1);
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'CO', 10, N'CourseTitle', N'Text', 150, 0, 0, 0, CAST(N'2018-10-03T20:23:51.577' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DAB', 16, N'DaysAbsent', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:27:04.103' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DC', 14, N'Dept', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:25:39.737' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DE', 6, N'DateEnded', N'Date', 120, 0, 0, 0, CAST(N'2018-10-03T20:24:00.970' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DS', 5, N'DateStarted', N'Date', 120, 0, 0, 0, CAST(N'2018-10-03T20:21:39.420' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DTY', 17, N'DaysTardy', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:27:23.657' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DY', 12, N'Meets', N'Text', 60, 0, 0, 0, CAST(N'2018-10-03T20:24:54.590' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'EIC', 15, N'EnrolledDays', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:26:38.143' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'NEWLINE1', 0, N'', N'', 0, 0, 0, 1, CAST(N'2018-10-03T20:21:48.860' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'NEWLINE2', 0, N'', N'', 0, 0, 0, 1, CAST(N'2018-10-03T20:21:52.767' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'PD', 9, N'Period', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:23:24.920' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'PNC', 20, N'PunctualPercentage', N'Text', 70, 0, 0, 0, CAST(N'2018-10-04T13:58:51.253' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'PRS', 19, N'PresentPercentage', N'Text', 70, 0, 0, 0, CAST(N'2018-10-03T20:28:26.853' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'S1', 13, N'GradReq', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:25:18.963' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SC', 1, N'SchoolCode', N'Text', 50, 0, 0, 0, CAST(N'2018-10-03T20:20:21.003' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SE', 7, N'Section', N'Text', 100, 0, 0, 0, CAST(N'2018-10-03T20:22:41.093' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SM', 8, N'Term', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:23:02.940' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SN', 3, N'StudentNumber', N'Text', 100, 0, 0, 0, CAST(N'2018-10-03T20:20:54.913' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'TE', 11, N'Teacher', N'Text', 300, 0, 0, 0, CAST(N'2018-10-03T20:24:18.960' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'TNE', 18, N'TempNotEnrolled', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:27:42.390' AS DateTime))

print 'APBP Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of APBP blocked by version control - APBP needs no update or was customized'
set nocount off
