--APDR - Attendance Percentage by Date Range - Custom View 
--APDS - Attendance Percentage Date Settings - Custom Table for option parameters used by APDR - Aeries Software - Jared Kuszewski
--Run line five to remove these if you wish
/* 
drop view APDR; delete from ctf where tc = 'APDR'; delete from ctd where tc = 'APDR'; drop table APDS delete from ctf where tc = 'APDS'; delete from ctd where tc = 'APDS';
*/
--############################################################################################################################
--If you wish to block future updates because you customized this now, specify a date in the far distant future in the next line. Line 5 can override by dropping first.
declare @version varchar(23) = '2022-09-26 16:45:00.000'
--############################################################################################################################
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'APDR'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'APDR'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale APDR view and APDS table if stale and recreate it
declare @SQL nvarchar(max) = N''
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDR''and o.[type_desc] = ''VIEW'') begin drop view APDR; delete from ctf where tc = ''APDR''; delete from ctd where tc = ''APDR''; end' exec (@SQL)
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@SQL)
set @SQL = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@SQL)
set @SQL = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@SQL)
set @SQL = N'

create view APDR as 
--APDR - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
--Remove Aeries Soft or make the version a far newer date in the line preceeding this if you wish to block updates by version control if you customize this view to your liking
--Days Enrolled, Days Present, Days Absent, ATT percentage, and tardies aggregated by school this DB year with custom date range at top
--Now Honors Tracks!

--Unpivotted Tracks from DAY in a CTE called tdays

with tdays (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
''A''+T1 as T1, 
''B''+T2 as T2, 
''C''+T3 as T3, 
''D''+T4 as T4, 
''E''+T5 as T5, 
''F''+T6 as T6, 
''G''+T7 as T7, 
''H''+T8 as T8, 
''I''+T9 as T9, 
''J''+T10 as T10, 
''K''+T11 as T11, 
''L''+T12 as T12, 
''M''+T13 as T13, 
''N''+T14 as T14, 
''O''+T15 as T15, 
''P''+T16 as T16, 
''Q''+T17 as T17, 
''R''+T18 as T18, 
''S''+T19 as T19, 
''T''+T20 as T20, 
''U''+T21 as T21, 
''V''+T22 as T22, 
''W''+T23 as T23, 
''X''+T24 as T24, 
''Y''+T25 as T25, 
''Z''+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv

union

select SC, DY, DT, AB, HO, BL, '' '' + HO AS TrackHO from day where DEL = 0
) trackdays
)




select 
(select convert(varchar(10),swh,101) from APDS where sc = dedpda.sc and sn = dedpda.sn) SWH, --[APDS Begining Range]
(select case when twh > getdate() then convert(varchar(10),getdate(),101) else convert(varchar(10),twh,101) end from APDS where sc = dedpda.sc and sn = dedpda.sn) TWH, --[APDS Ending Range or Today]
SC, ID, SN, LN, FN, YR,
[Days Enrolled] - [Days Not Enrolled] DE, 
[Days Not Enrolled] NE, 
[Days Enrolled] - [Days Not Enrolled] - [days Absent] as DP, --[days Present]
[days Absent] DA, 
[days Made Up] DMU, 
case when [Days Enrolled] <> 0 then cast(cast( ([Days Enrolled] - [Days Not Enrolled] - [days Absent] + [days Made Up]) / cast([Days Enrolled] - [Days Not Enrolled] as dec(10,3)) * 100 as float) as varchar(50)) + ''%'' 
else '''' end as APR, --ATTPercentage
Tardies TAR 
,0 DEL
,getdate() DTS
from 
(
select SC, ID, SN, LN, FN, YR, sum([Days Enrolled]) as [Days Enrolled], sum([Days Not Enrolled]) as [Days Not Enrolled], sum([days Absent]) as [days Absent], sum([days Made Up]) as [days Made UP], sum(Tardies) as Tardies from 
(select 
stu.sc, stu.id, stu.sn, stu.ln, stu.fn,
enr.yr, enr.pr, enr.ED, enr.LD,


(select count(*) from tdays inner join enr as enr2 on tdays.dt >= enr2.ed
where ho not in (''@'',''#'',''$'',''*'')  
and enr2.sc = [tdays].sc
and [tdays].sc = stu.sc
and enr2.id = stu.id
and enr2.yr = ''20'' + substring(db_name(),4,2)
and [tdays].dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) end
and [tdays].dt >= case when (select swh from APDS where sc = enr2.sc and sn = enr2.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = enr2.sc and sn = enr2.sn) end
and [tdays].dt <= case when enr2.ld is not null then enr2.ld else case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) end end
and enr2.del = 0 
and [tdays].dt >= enr.ed and [tdays].dt <= (case when enr.ld is not null then enr.ld else [tdays].dt end)
and enr2.sc = stu.sc
and tdays.track = stu.tr
) as [Days Enrolled],

(select count(*) from att where del = 0 and al in (select cd from [abs] where del = 0 and sc = stu.sc and ad <> 1 and ne <> 1) and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as [days Absent],

(select count(*) from att where del = 0 and ada > '''' and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as [days Made Up],

(select count(*) from att where AL in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a0 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a1 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a2 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a3 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a4 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a5 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a6 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a7 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a8 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a9 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as Tardies

,(select count(*) from att where AL in (select cd from [abs] where ne = 1 and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as [Days Not Enrolled]
from stu inner join enr on stu.id = enr.id and stu.sc = enr.sc
where right(enr.yr,2) = substring(db_name(),4,2)
and stu.del = 0 and enr.del = 0

) deda

WHERE [Days Enrolled] > 0
group by SC, ID, SN, LN, FN, YR) dedpda
' exec(@SQL)
set @SQL = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDR'', N''Attendance Percentage by Date Range'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:42:50.370'' AS DateTime), 1)
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''SWH'', 1, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-23T08:54:21.077'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''TWH'', 2, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-23T08:54:43.180'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DE'', 9, N''Days Enrolled'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:04:28.747'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''NE'', 10, N''Days Not Enrolled'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:04:41.347'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DP'', 11, N''Days Present'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:05:33.237'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DA'', 12, N''Days Absent'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:05:48.460'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DMU'', 13, N''Days Made Up'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:06:00.750'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''APR'', 14, N''Attendance Percentage'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:06:00.750'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''TAR'', 15, N''Tardies'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:06:07.747'' AS DateTime))
'
EXEC (@SQL)

set @SQL = N'INSERT APDS (SC, SN) select top 1 sc, sn from stu where del = 0'
EXEC (@SQL)

print 'APDS and APDR Custom Table and View Created or Refreshed!'
set nocount off
END

else print 'Update of APDS and APDR blocked by version control - APDS and APDR need no update or were customized'
set nocount off