--APFP - Attendance Percentage by Flex Period - Custom View 
--APFS - Attendance Percentage by Flex Summary - Custom View 
--APDS - Attendance Percentage Date Settings - Custom Table for option parameters used by APFP - Aeries Software - Jared Kuszewski
--Run line six to remove these if you wish
/* 
drop view APFS; delete from ctf where tc = 'APFS'; delete from ctd where tc = 'APFS'; drop view APFP; delete from ctf where tc = 'APFP'; delete from ctd where tc = 'APFP'; drop table APDS; delete from ctf where tc = 'APDS'; delete from ctd where tc = 'APDS';
*/
--############################################################################################################################
--If you wish to block future updates because you customized this now, specify a date in the far distant future in the next line. Line 5 can override by dropping first.
declare @version varchar(23) = '2022-09-26 16:45:00.000'
--############################################################################################################################
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'APFP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'APFP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale APFP/APFS views and APDS table if stale and recreate it
declare @SQL nvarchar(max) = N''
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APFS''and o.[type_desc] = ''VIEW'') begin drop view APFS; delete from ctf where tc = ''APFS''; delete from ctd where tc = ''APFS''; end' exec (@SQL)
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APFP''and o.[type_desc] = ''VIEW'') begin drop view APFP; delete from ctf where tc = ''APFP''; delete from ctd where tc = ''APFP''; end' exec (@SQL)
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@SQL)
set @SQL = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@SQL)
set @SQL = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@SQL)


set @SQL = N'create view APFP as 
--APFP - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
WITH TDAYS (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
''A''+T1 as T1, 
''B''+T2 as T2, 
''C''+T3 as T3, 
''D''+T4 as T4, 
''E''+T5 as T5, 
''F''+T6 as T6, 
''G''+T7 as T7, 
''H''+T8 as T8, 
''I''+T9 as T9, 
''J''+T10 as T10, 
''K''+T11 as T11, 
''L''+T12 as T12, 
''M''+T13 as T13, 
''N''+T14 as T14, 
''O''+T15 as T15, 
''P''+T16 as T16, 
''Q''+T17 as T17, 
''R''+T18 as T18, 
''S''+T19 as T19, 
''T''+T20 as T20, 
''U''+T21 as T21, 
''V''+T22 as T22, 
''W''+T23 as T23, 
''X''+T24 as T24, 
''Y''+T25 as T25, 
''Z''+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv

union 
select SC, DY, DT, AB, HO, BL, '' '' + HO AS TrackHO from day where DEL = 0
) trackdays
)

SELECT SC, SN, SE, CN, CO, DC, S1 GRQ
,(SELECT STI FROM FTF WHERE B.FSQ = SQ AND SC = B.SC AND DEL = 0) STI
,(SELECT DE FROM FTF WHERE B.FSQ = SQ AND SC = B.SC AND DEL = 0) PDE
,
STUFF(
(SELECT  '' | '',STF.FN + '' '' + STF.LN
FROM SSE 
INNER JOIN STF ON SSE.ID = STF.ID
WHERE SSE.DEL = 0 AND STF.DEL = 0 AND SSE.TG = '''' 
AND TWH BETWEEN
COALESCE(SD,''1/1/1900'')
AND
COALESCE(ED,''12/31/9999'')
AND SSE.SC = B.SC AND SSE.SE = B.SE
ORDER BY PR DESC, SD
FOR XML PATH (''''))
, 1, 3, '''') TE
, ENR, DA, ENR - DA DP, TRD, DNE
, CASE WHEN ENR - DA > 0 and ENR - DA > 0 THEN LEFT((ENR - DA) / (ENR * 1.0) * 100,6) ELSE ''0'' END + ''%'' PRC
, SWH, TWH, 1 SQ, 0 DEL, GETDATE() DTS
FROM (
SELECT SC, SN, SE, CN, CO, DC, S1, FSQ
,SUM(ENR) ENR
,SUM(DA) DA
,SUM(TRD) TRD
,SUM(DNE) DNE
, SWH, TWH
FROM(
SELECT STU.SC, STU.SN
,CAR.SE
,CAR.CN
,CRS.CO
,CRS.DC
,CRS.S1
,MST.FSQ
,1 ENR
,CASE WHEN CAT.AC IN (SELECT CD FROM ABS WHERE DEL = 0 AND AD = 0 AND SC = STU.SC) THEN 1 ELSE 0 END DA
,CASE WHEN CAT.AC IN (SELECT CD FROM ABS WHERE DEL = 0 AND TY IN (''5'',''8'',''9'') AND SC = STU.SC) THEN 1 ELSE 0 END TRD
,CASE WHEN CAT.AC IN (SELECT CD FROM ABS WHERE DEL = 0 AND NE = 1 AND SC = STU.SC) THEN 1 ELSE 0 END DNE
,CASE WHEN COALESCE(APDS.SWH,''1/1/1900'') > CAR.DS THEN APDS.SWH ELSE CAR.DS END SWH
,CASE 
WHEN GETDATE() <  COALESCE(APDS.TWH,''12/31/9999'') AND GETDATE() < CAR.DE THEN GETDATE()
WHEN COALESCE(APDS.TWH,''12/31/9999'') < CAR.DE THEN APDS.TWH
ELSE CAR.DE END TWH

FROM 
(SELECT SC, SN, ID, TR FROM STU WHERE DEL = 0) STU
INNER JOIN (SELECT * FROM CAR WHERE DEL = 0) CAR ON STU.SC = CAR.SC AND STU.SN = CAR.SN
LEFT JOIN (SELECT * FROM CRS WHERE DEL = 0) CRS ON CAR.CN = CRS.CN
INNER JOIN (SELECT * FROM TDAYS WHERE DT < GETDATE() AND HO NOT IN (''@'',''#'',''$'',''*'')) TDAYS ON TDAYS.SC = STU.SC AND TDAYS.Track = STU.TR
LEFT JOIN (SELECT * FROM MST WHERE DEL = 0) MST ON MST.SC = CAR.SC AND MST.SE = CAR.SE
INNER JOIN (SELECT * FROM CCD WHERE DEL = 0) CCD ON MST.CSQ = CCD.CSQ AND CCD.DT = TDAYS.DT
LEFT JOIN (SELECT * FROM CAT WHERE DEL = 0) CAT ON CAT.SCL = STU.SC AND CAT.ID = STU.ID AND CAT.SE = CAR.SE AND CAT.DT = TDAYS.DT 
LEFT JOIN (SELECT * FROM APDS WHERE DEL = 0) APDS ON APDS.SC = STU.SC AND APDS.SN = STU.SN 
WHERE
STU.SC IN (SELECT DISTINCT SC FROM CAR WHERE DEL = 0)
AND STU.SC IN (SELECT DISTINCT SC FROM FTF WHERE DEL = 0)
AND TDAYS.DT BETWEEN CAR.DS AND CAR.DE
AND TDAYS.DT BETWEEN 
CASE WHEN COALESCE(APDS.SWH,''1/1/1900'') > CAR.DS THEN APDS.SWH ELSE CAR.DS END 
AND 
CASE WHEN COALESCE(APDS.TWH,''12/31/9999'') < CAR.DE THEN APDS.TWH ELSE CAR.DE END

--AND STU.SC = 41
--AND STU.SN = 1576

) A
GROUP BY SC, SN, SE, CN, CO, DC, S1, FSQ, SWH, TWH
) B
' exec(@SQL)

set @SQL = N'create view APFS as 
--APFS - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
SELECT SC, SN, ENR, DP, 
CASE WHEN DP > 0 THEN CAST(CAST(((DP * 1.0) / ENR) * 100 AS DEC (12,2)) AS VARCHAR(20)) + ''%'' ELSE '''' END AS PRC,
DEL, DTS from 
(
SELECT SC, SN, SUM(ENR) ENR, SUM(DP) DP, 0 DEL, GETDATE() DTS
FROM APFP
GROUP BY SC, SN
) A
' exec(@SQL)

set @SQL = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [VW], [DEL], [DTS]) VALUES (N''APFP'', N''Attendance Percentage by Flex Period'', N''Student Data'', N''SC,SN,SQ'', N''STU'', N''SC,SN'', N''SC,SN'', N''Many'', N''SC,SN,STI,CN'', 1, 0, CAST(N''2021-10-27T13:37:04.807'' AS DateTime))
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [VW], [DEL], [DTS]) VALUES (N''APFS'', N''Attendance Percentage by Flex Summary'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 1, 0, CAST(N''2021-12-08T08:04:39.333'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''CN'', 2, N''Course Number'', N''Text'', 70, 0, 0, 0, CAST(N''2021-10-27T13:40:09.230'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''CO'', 3, N''Course Title'', N''Text'', 170, 0, 0, 0, CAST(N''2021-10-27T13:40:35.570'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DA'', 15, N''Days Absent'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DC'', 4, N''Dept Code'', N''Text'', 50, 0, 0, 0, CAST(N''2021-10-27T13:41:21.680'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DNE'', 18, N''Days Not Enrolled'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.857'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DP'', 16, N''Days Present'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''ENR'', 14, N''Enrolled Days'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''GRQ'', 5, N''Grad Req 1'', N''Text'', 60, 0, 0, 0, CAST(N''2021-10-27T19:47:47.423'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''NEWLINE1'', 6, N'''', N'''', 0, 0, 0, 0, CAST(N''2021-10-27T13:42:01.837'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''NEWLINE2'', 13, N'''', N'''', 0, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''NEWLINE3'', 8, N'''', N'''', 0, 0, 0, 0, CAST(N''2021-10-27T19:48:46.810'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''PDE'', 12, N''Period Desc'', N''Text'', 150, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''PRC'', 19, N''Att Percentage'', N''Text'', 80, 0, 0, 0, CAST(N''2021-10-27T19:48:46.857'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''SE'', 1, N''Section'', N''Text'', 50, 0, 0, 0, CAST(N''2021-10-27T13:39:36.667'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''STI'', 11, N''Period'', N''Text'', 70, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''SWH'', 9, N''Since When'', N''Date'', 120, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''TE'', 7, N''Teacher(s)'', N''Text'', 600, 0, 0, 0, CAST(N''2021-10-27T19:48:46.810'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''TRD'', 17, N''Tardy'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.857'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''TWH'', 10, N''Till When'', N''Date'', 120, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFS'', N''DP'', 4, N''Sum of Periods Present'', N''Number'', 40, 0, 0, 0, CAST(N''2021-12-08T08:07:25.297'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFS'', N''ENR'', 3, N''Sum of Enrolled Periods'', N''Number'', 40, 0, 0, 0, CAST(N''2021-12-08T08:06:53.507'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFS'', N''PRC'', 5, N''Percent Attended'', N''Text'', 100, 0, 0, 0, CAST(N''2021-12-08T08:08:08.843'' AS DateTime))
'
EXEC (@SQL)

set @SQL = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
'
EXEC (@SQL)

set @SQL = N'INSERT APDS (SC, SN) select top 1 sc, sn from stu where del = 0'
EXEC (@SQL)

print 'APDS and APFP/APFS Custom Table and Views Created or Refreshed!'
set nocount off
END

else print 'Update of APDS and APFP/APFS blocked by version control - APDS and APFP/APFS need no update or were customized'
set nocount off
