--GBKA - Gradebook Use Analysis - Custom View - Aeries Software - Jared Kuszewski
--Create GBKA Custom View if not present - Run line 4 if you wish to drop a prior GBKA rendition before I added version control
/* 
drop view GBKA; delete from ctf where tc = 'GBKA'; delete from ctd where tc = 'GBKA';
*/
declare @version varchar(23) = '2019-02-07 08:13:00.000'
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'GBKA'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > --your version here
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'GBKA'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale GBKA view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''GBKA''and o.[type_desc] = ''VIEW'') begin drop view GBKA end; delete from ctf where tc = ''GBKA''; delete from ctd where tc = ''GBKA'';'
exec (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
--GBKA - Gradebook Use Analysis - Custom View - Jared Kuszewski - Aeries Software - Version = ''' + @version + '''
create view GBKA as
--Gradebook Analysis (GBKA) - 10/04/2018 Jared Kuszewski Aeries Software
--Sorted by department and median percent descending
--Note: Initial gradebook name and period may not match later decisions to associate to a section for a different period or Course.
--Purpose: This gives administration one perspective of how their team of teachers is performing in grading. This can be a conversation starter. Use caution presuming it to tell you the whole story. An Easy "A" may not be good and harsh grades can be bad too. Since competitive options of school choices are available, it is good to know that your team is on point. You can assist those that may need help.
select SchoolNum SC,
ISNULL((SELECT TOP 1 SN FROM STU WHERE SC = SCHOOLNUM AND DEL = 0 AND TG = '''' ORDER BY LN, FN),0) SN,
1 SQ, 
SchoolName NM, 
TeacherName TE, 
GBK_Num GNB, 
GBK_Name GNM, 
CourseTitle CO, 
Dept DC, 
GradReq S1, 
GB_Term TM, 
pd PD, 
MinPercent MNP, 
AvgPercent AVP, 
MedianPercent MDP, 
MaxPercent MXP, 
AssignmentCount ACN, 
StuCount UDS, 
MinDueDate MDT, 
MedianDueDate MDD, 
MaxDueDate MXD,
LastUpdated LUP,
0 DEL,
CURRENT_TIMESTAMP DTS

from (

select gbk.sc SchoolNum, loc.nm SchoolName, tch.te TeacherName, gbk.gn GBK_Num, gbk.nm GBK_Name, crs.co CourseTitle, crs.dc Dept, crs.s1 GradReq, gbr.cd GB_Term, gbk.pd, 
min(gbv.pc) MinPercent, 
avg(gbv.pc) AvgPercent
,((select max(pc) from (select top 50 percent pc from gbv v where gn = gbk.gn and cd = gbr.cd 
and pc <> 0 --omit zero percent (This takes willful disobedience)
order by pc) A) + 
(select min(pc) from (select top 50 percent pc from gbv v where gn = gbk.gn and cd = gbr.cd 
and pc <> 0 --omit zero percent (This takes willful disobedience)
order by pc desc) B)) / 2 MedianPercent
, max(gbv.pc) MaxPercent
,(select count(*) from gba where gn = gbk.gn and dd between gbr.sd and gbr.ed) AssignmentCount
, (select count(*) from gbu where sc = gbk.sc and gn = gbk.gn and gbu.d1 <= gbr.ed and (gbu.d2 is null or gbu.d2 >= gbr.sd

and tg <> ''I'' --and not dropped with this line

 )) STUcount
,convert(varchar(10),(select min(dd) from gba where gn = gbk.gn and dd between gbr.sd and gbr.ed),101) as MinDueDate 
,convert(varchar(10),cast(((select max(cast(dd as bigint)) from (select top 50 percent dd from GBA d where gn = gbk.gn and dd between gbr.sd and gbr.ed order by dd) A) + 
(select min(cast(dd as bigint)) from (select top 50 percent dd from GBA d where gn = gbk.gn and dd between gbr.sd and gbr.ed order by dd desc) B)) / 2 as datetime),101)  MedianDueDate
,convert(varchar(10),(select max(dd) from gba where gn = gbk.gn and dd between gbr.sd and gbr.ed),101) as MaxDueDate
,(select max(dts) from gbv v where gn = gbk.gn) LastUpdated
from gbk inner join gbu on gbk.gn = gbu.gn and gbk.sc = gbu.sc
inner join loc on gbk.sc = loc.cd
inner join tch on gbk.sc = tch.sc and gbk.tn = tch.tn
inner join gbv on gbu.sc = gbv.sc and gbu.sn = gbv.sn and gbu.gn = gbv.gn
inner join gbr on gbk.gn = gbr.gn and gbv.cd = gbr.cd
left join gbe on gbk.gn = gbe.gn
left join mst on gbe.sc = mst.sc and gbe.se = mst.se
left join crs on mst.cn = crs.cn
where gbu.d1 <= gbr.ed and (gbu.d2 is null or gbu.d2 >= gbr.sd)

and gbu.tg <> ''I'' --and not dropped with this line

and gbv.pc <> 0 --omit zero percent (This takes willful disobedience)

group by 
gbk.sc, gbk.gn, loc.nm, tch.te, gbk.nm, crs.co, crs.dc, crs.s1, gbr.cd, gbk.pd, gbr.sd, gbr.ed
) gb
where STUcount > 1 --omitting gradebooks with just one kid (likely Teacher''s Aides)
'

exec (@DynaQuery)

INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'GBKA', N'Gradebook Analysis', N'', N'SC,SN,SQ', N'STU', N'SC,SN', N'SC,SN', N'Many', N'SC,DC,MDP DESC', 0, CAST(N'2018-10-04T23:56:31.573' AS DateTime), 1)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'NM', 1, N'SchoolName', N'Text', 300, 0, 0, 0, CAST(N'2018-10-04T23:57:32.687' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'TE', 2, N'TeacherName', N'Text', 300, 0, 0, 0, CAST(N'2018-10-04T23:58:03.573' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'GNB', 3, N'GBNumber', N'Text', 100, 0, 0, 0, CAST(N'2018-10-04T23:59:14.470' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'GNM', 4, N'GradebookName', N'Text', 300, 0, 0, 0, CAST(N'2018-10-04T23:59:43.653' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'CO', 5, N'CourseTitle', N'Text', 300, 0, 0, 0, CAST(N'2018-10-05T00:00:32.937' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'DC', 6, N'Dept', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:02:35.873' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'S1', 7, N'GradReq', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:02:29.567' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'TM', 8, N'Term', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:02:54.617' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'PD', 9, N'Period', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:03:20.870' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MNP', 10, N'MinPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:03:58.647' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'AVP', 11, N'AvgPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:04:27.357' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MDP', 12, N'MedianPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:05:48.000' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MXP', 13, N'MaxPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:06:10.383' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'ACN', 14, N'AssignmentCount', N'Text', 40, 0, 0, 0, CAST(N'2018-10-05T00:06:42.340' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'UDS', 15, N'UndroppedSTUcount', N'Text', 40, 0, 0, 0, CAST(N'2018-10-05T00:07:35.507' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MDT', 16, N'MinDueDate', N'Date', 100, 0, 0, 0, CAST(N'2018-10-05T00:08:10.500' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MDD', 17, N'MedianDueDate', N'Date', 100, 0, 0, 0, CAST(N'2018-10-05T00:08:31.320' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MXD', 18, N'MaxDueDate', N'Date', 100, 0, 0, 0, CAST(N'2018-10-05T00:08:59.377' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'LUP', 19, N'LastUpdated', N'Text', 300, 0, 0, 0, CAST(N'2018-10-05T00:09:42.560' AS DateTime))

print 'GBKA Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of GBKA blocked by version control - GBKA needs no update or was customized.'
set nocount off
