--GradebookClassStats - Custom View - Aeries Software - Jared Kuszewski
--Create GradebookClassStats Custom View if not present - Run line 4 if you wish to drop a prior GradebookClassStats rendition
/* 
drop view GradebookClassStats; delete from ctf where tc = 'GradebookClassStats'; delete from ctd where tc = 'GradebookClassStats';
*/
declare @version varchar(23) = '2019-03-01 20:00:00.000'
set nocount on
if exists (select top 1 1 from sys.objects o inner join sys.sql_modules m on o.object_id = m.object_id where o.[name] = 'GBKA')
BEGIN
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'GradebookClassStats'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > --your version here
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'GradebookClassStats'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale GradebookClassStats view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''GradebookClassStats''and o.[type_desc] = ''VIEW'') begin drop view GradebookClassStats end; delete from ctf where tc = ''GradebookClassStats''; delete from ctd where tc = ''GradebookClassStats'';'
exec (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
Create VIEW GradebookClassStats
as
SELECT        STU.SC, STU.SN, 
ROW_NUMBER() OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, GBKA.PD, GBKA.TM, GBKA.NM) SQ
,GBV.MK YMK, GBV.PC YPC
, GBKA.NM, GBKA.TE, GBKA.GNB, GBKA.GNM, GBKA.CO, GBKA.DC, GBKA.S1, GBKA.TM, GBKA.PD, GBKA.MNP, GBKA.AVP, GBKA.MDP, GBKA.MXP, GBKA.ACN, GBKA.UDS, GBKA.MDT, GBKA.MDD, GBKA.MXD, GBKA.LUP, GBKA.DEL, GBKA.DTS
FROM            
GBKA INNER JOIN GBU ON GBU.GN = GBKA.GNB
INNER JOIN STU ON STU.SC = GBU.SC AND STU.SN = GBU.SN AND STU.DEL = 0
INNER JOIN GBV ON STU.SC = GBV.SC AND STU.SN = GBV.SN AND GBV.GN = GBKA.GNB AND GBV.CD = GBKA.TM
'

exec (@DynaQuery)

INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'GradebookClassStats', N'Gradebook Class Statistics', N'Student Data|Grades', N'SC,SN,SQ', N'STU', N'SC,SN', N'SC,SN', N'Many', N'SQ', 0, CAST(N'2019-02-05T08:32:42.840' AS DateTime), 1)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'DC', 0, N'Dept', N'Text', 15, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'GNB', 0, N'GBNumber', N'Text', 100, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'S1', 0, N'GradReq', N'Text', 15, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NM', 0, N'SchoolName', N'Text', 300, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'TE', 1, N'Teacher Name', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T19:18:23.143' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'GNM', 2, N'Gradebook Name', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T19:18:20.060' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'CO', 3, N'Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T20:00:28.553' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'TM', 4, N'Term', N'Text', 15, 0, 0, 0, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'PD', 5, N'Period', N'Text', 15, 0, 0, 0, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE4', 6, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:15:38.347' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'YMK', 7, N'Your Mark', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:17:06.373' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'YPC', 8, N'Your Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:17:06.377' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE1', 9, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:17:06.383' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MNP', 10, N'Class Minimum Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:18:40.920' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'AVP', 11, N'Class Average Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:18:56.360' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MDP', 12, N'Class Median Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:19:04.677' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MXP', 13, N'Class Max Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:19:16.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE2', 14, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:17:06.403' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'ACN', 15, N'Total Assignments This Term', N'Text', 40, 0, 0, 0, CAST(N'2019-03-01T19:19:57.127' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'UDS', 16, N'Students in this Gradebook', N'Text', 40, 0, 0, 0, CAST(N'2019-03-01T19:20:14.393' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE3', 17, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:17:06.410' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MDT', 18, N'Earliest Assigment Due Date', N'Date', 100, 0, 0, 0, CAST(N'2019-03-01T19:20:50.703' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MDD', 19, N'Median Assignment Due Date', N'Date', 100, 0, 0, 0, CAST(N'2019-03-01T19:58:52.090' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MXD', 20, N'Latest Assignment Due Date (at this time)', N'Date', 100, 0, 0, 0, CAST(N'2019-03-01T19:59:06.057' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE5', 21, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:59:51.070' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'LUP', 22, N'Last Updated (for this class)', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T19:59:51.073' AS DateTime))


print 'GradebookClassStats Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of GradebookClassStats blocked by version control - GradebookClassStats needs no update or was customized.'
set nocount off
END
else Print 'This depends on the existence of GBKA. Please create that view first.'