--MSTP - Classes pivoted for the current or custom day in APDS.JOD - Custom View - Aeries Software - Jared Kuszewski
--So if students attend different classes each day or you use A/B day scheduling. Just use this on a similar dayof the week.
--Create MSTP Custom View if not present - Run line 5 if you wish to drop a prior MSTP rendition before I added version control
/* 
drop view MSTP; delete from ctf where tc = 'MSTP'; delete from ctd where tc = 'MSTP';drop table APDS; delete from ctf where tc = 'APDS'; delete from ctd where tc = 'APDS';
*/
declare @version varchar(23) = '2022-09-26 16:45:00.000' --Specify a date in the distant future like 2199-01-01 to block revisions if you have customized this

set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'MSTP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'MSTP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale MSTP view if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''MSTP''and o.[type_desc] = ''VIEW'') begin drop view MSTP end; delete from ctf where tc = ''MSTP''; delete from ctd where tc = ''MSTP'';'
exec (@DynaQuery)
set @DynaQuery = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@DynaQuery)
set @DynaQuery = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@DynaQuery)
set @DynaQuery = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@DynaQuery)

set @DynaQuery = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
'
EXEC (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
--MSTP - Classes pivoted for the current Day - Custom View - Jared Kuszewski - Aeries Software - Version = ''' + @version + '''
Create View [dbo].[MSTP] as

WITH TDAYS (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
''A''+T1 as T1, 
''B''+T2 as T2, 
''C''+T3 as T3, 
''D''+T4 as T4, 
''E''+T5 as T5, 
''F''+T6 as T6, 
''G''+T7 as T7, 
''H''+T8 as T8, 
''I''+T9 as T9, 
''J''+T10 as T10, 
''K''+T11 as T11, 
''L''+T12 as T12, 
''M''+T13 as T13, 
''N''+T14 as T14, 
''O''+T15 as T15, 
''P''+T16 as T16, 
''Q''+T17 as T17, 
''R''+T18 as T18, 
''S''+T19 as T19, 
''T''+T20 as T20, 
''U''+T21 as T21, 
''V''+T22 as T22, 
''W''+T23 as T23, 
''X''+T24 as T24, 
''Y''+T25 as T25, 
''Z''+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv
where ascii(left(TrackHO,1)) between 64 and (64 + (select k from loc where del = 0 and cd = unpiv.sc))
union 
select SC, DY, DT, AB, HO, BL, '' '' + HO AS TrackHO from day where DEL = 0
) trackdays
)

--The MST Class Pivot

SELECT SC, SN
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN SM END),'''') SM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(PD AS VARCHAR(6)) END),'''') PD1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(se AS VARCHAR(5)) END),'''') SE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(TE AS VARCHAR(500)) END),'''') TE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN RM END),'''') RM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CN END),'''') CN1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CO END),'''') CO1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN DE END),'''') DE1

,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN SM END),'''') SM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(PD AS VARCHAR(6)) END),'''') PD2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(se AS VARCHAR(5)) END),'''') SE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(TE AS VARCHAR(500)) END),'''') TE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN RM END),'''') RM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CN END),'''') CN2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CO END),'''') CO2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN DE END),'''') DE2

,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN SM END),'''') SM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(PD AS VARCHAR(6)) END),'''') PD3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(se AS VARCHAR(5)) END),'''') SE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(TE AS VARCHAR(500)) END),'''') TE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN RM END),'''') RM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CN END),'''') CN3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CO END),'''') CO3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN DE END),'''') DE3

,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN SM END),'''') SM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(PD AS VARCHAR(6)) END),'''') PD4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(se AS VARCHAR(5)) END),'''') SE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(TE AS VARCHAR(500)) END),'''') TE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN RM END),'''') RM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CN END),'''') CN4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CO END),'''') CO4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN DE END),'''') DE4

,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN SM END),'''') SM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(PD AS VARCHAR(6)) END),'''') PD5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(se AS VARCHAR(5)) END),'''') SE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(TE AS VARCHAR(500)) END),'''') TE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN RM END),'''') RM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CN END),'''') CN5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CO END),'''') CO5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN DE END),'''') DE5

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN SM END),'''') SM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(PD AS VARCHAR(6)) END),'''') PD6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(se AS VARCHAR(5)) END),'''') SE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(TE AS VARCHAR(500)) END),'''') TE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN RM END),'''') RM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CN END),'''') CN6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CO END),'''') CO6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN DE END),'''') DE6

,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN SM END),'''') SM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(PD AS VARCHAR(6)) END),'''') PD7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(se AS VARCHAR(5)) END),'''') SE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(TE AS VARCHAR(500)) END),'''') TE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN RM END),'''') RM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CN END),'''') CN7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CO END),'''') CO7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN DE END),'''') DE7

,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN SM END),'''') SM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(PD AS VARCHAR(6)) END),'''') PD8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(se AS VARCHAR(5)) END),'''') SE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(TE AS VARCHAR(500)) END),'''') TE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN RM END),'''') RM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CN END),'''') CN8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CO END),'''') CO8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN DE END),'''') DE8

,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN SM END),'''') SM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(PD AS VARCHAR(6)) END),'''') PD9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(se AS VARCHAR(5)) END),'''') SE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(TE AS VARCHAR(500)) END),'''') TE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN RM END),'''') RM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CN END),'''') CN9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CO END),'''') CO9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN DE END),'''') DE9

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN SM END),'''') SM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(PD AS VARCHAR(6)) END),'''') PD10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(se AS VARCHAR(5)) END),'''') SE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(TE AS VARCHAR(500)) END),'''') TE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN RM END),'''') RM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CN END),'''') CN10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CO END),'''') CO10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN DE END),'''') DE10
,0 DEL
,GETDATE() DTS

FROM (
SELECT STU.SC, STU.SN, MST.SM, MST.PD, MST.SE, TCH.TE, MST.RM, CRS.CN, CRS.CO, CRS.DE,
ROW_NUMBER () OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, MST.PD, MST.SE) ClassOrder
FROM
STU 
LEFT JOIN SEC ON STU.SC = SEC.SC AND STU.SN = SEC.SN AND SEC.DEL = 0
LEFT JOIN MST ON SEC.SC = MST.SC  AND SEC.SE = MST.SE AND MST.DEL = 0
LEFT JOIN CRS ON MST.CN = CRS.CN AND CRS.DEL = 0
LEFT JOIN TCH ON MST.SC = TCH.SC AND MST.TN = TCH.TN AND TCH.DEL = 0
WHERE STU.DEL = 0
AND STU.SC NOT IN (SELECT CD FROM LOC WHERE DEL = 0 AND E = ''3'')
AND (MST.SM IS NULL OR MST.SM 
IN (SELECT TM FROM TRM 
WHERE CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END BETWEEN D1 AND D2)) --ONLY CURRENT TERMS
AND STU.SC IN (SELECT CD FROM LOC WHERE E in (0,2) AND DEL = 0 AND TG = '''') --Just master schedule schools
AND 1 = CASE 
WHEN MST.DY = ''A-DAYS'' AND 
CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END
= (SELECT DT FROM TDAYS WHERE SC = STU.SC AND Track = STU.TR AND AB = ''A'' AND BL LIKE (''%'' + CAST(MST.PD AS VARCHAR(1)) + ''%'') AND DT 
= CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END) THEN 1
WHEN MST.DY = ''B-DAYS'' AND 
CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END
= (SELECT DT FROM TDAYS WHERE SC = STU.SC AND Track = STU.TR AND AB = ''B'' AND BL LIKE (''%'' + CAST(MST.PD AS VARCHAR(1)) + ''%'') AND DT 
= CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END) THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 2 AND MST.MM = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 3 AND MST.MT = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 4 AND MST.MW = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 5 AND MST.MR = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 6 AND MST.MF = 1 THEN 1
ELSE 0
END
) Classes

GROUP BY SC, SN


union all

'
select @DynaQuery += N'
--The MST Class Pivot FLEX
SELECT SC, SN
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN SM END),'''') SM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(PD AS VARCHAR(6)) END),'''') PD1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(se AS VARCHAR(5)) END),'''') SE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(TE AS VARCHAR(500)) END),'''') TE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN RM END),'''') RM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CN END),'''') CN1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CO END),'''') CO1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN DE END),'''') DE1

,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN SM END),'''') SM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(PD AS VARCHAR(6)) END),'''') PD2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(se AS VARCHAR(5)) END),'''') SE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(TE AS VARCHAR(500)) END),'''') TE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN RM END),'''') RM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CN END),'''') CN2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CO END),'''') CO2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN DE END),'''') DE2

,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN SM END),'''') SM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(PD AS VARCHAR(6)) END),'''') PD3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(se AS VARCHAR(5)) END),'''') SE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(TE AS VARCHAR(500)) END),'''') TE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN RM END),'''') RM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CN END),'''') CN3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CO END),'''') CO3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN DE END),'''') DE3

,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN SM END),'''') SM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(PD AS VARCHAR(6)) END),'''') PD4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(se AS VARCHAR(5)) END),'''') SE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(TE AS VARCHAR(500)) END),'''') TE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN RM END),'''') RM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CN END),'''') CN4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CO END),'''') CO4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN DE END),'''') DE4

,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN SM END),'''') SM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(PD AS VARCHAR(6)) END),'''') PD5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(se AS VARCHAR(5)) END),'''') SE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(TE AS VARCHAR(500)) END),'''') TE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN RM END),'''') RM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CN END),'''') CN5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CO END),'''') CO5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN DE END),'''') DE5

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN SM END),'''') SM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(PD AS VARCHAR(6)) END),'''') PD6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(se AS VARCHAR(5)) END),'''') SE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(TE AS VARCHAR(500)) END),'''') TE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN RM END),'''') RM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CN END),'''') CN6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CO END),'''') CO6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN DE END),'''') DE6

,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN SM END),'''') SM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(PD AS VARCHAR(6)) END),'''') PD7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(se AS VARCHAR(5)) END),'''') SE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(TE AS VARCHAR(500)) END),'''') TE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN RM END),'''') RM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CN END),'''') CN7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CO END),'''') CO7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN DE END),'''') DE7

,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN SM END),'''') SM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(PD AS VARCHAR(6)) END),'''') PD8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(se AS VARCHAR(5)) END),'''') SE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(TE AS VARCHAR(500)) END),'''') TE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN RM END),'''') RM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CN END),'''') CN8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CO END),'''') CO8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN DE END),'''') DE8

,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN SM END),'''') SM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(PD AS VARCHAR(6)) END),'''') PD9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(se AS VARCHAR(5)) END),'''') SE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(TE AS VARCHAR(500)) END),'''') TE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN RM END),'''') RM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CN END),'''') CN9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CO END),'''') CO9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN DE END),'''') DE9

,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN SM END),'''') SM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(PD AS VARCHAR(6)) END),'''') PD10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(se AS VARCHAR(5)) END),'''') SE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(TE AS VARCHAR(500)) END),'''') TE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN RM END),'''') RM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CN END),'''') CN10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CO END),'''') CO10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN DE END),'''') DE10
,0 DEL
,GETDATE() DTS

'
select @DynaQuery += N'

FROM (
SELECT 
STU.SC, STU.SN, MST.SM, FTF.STI PD, MST.SE, 
STUFF(
(SELECT  '' | '',STF.FN + '' '' + STF.LN
FROM SSE 
INNER JOIN STF ON SSE.ID = STF.ID
WHERE SSE.DEL = 0 AND STF.DEL = 0 AND SSE.TG = '''' 
AND COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy'')) BETWEEN
COALESCE(SD,''1/1/1900'')
AND
COALESCE(ED,''12/31/9999'')
AND SSE.SC = MST.SC AND SSE.SE = MST.SE
ORDER BY PR DESC, SD
FOR XML PATH (''''))
, 1, 3, '''') TE
, MST.RM, CRS.CN, CRS.CO, CRS.DE,
ROW_NUMBER () OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, CAST(FORMAT(FTF.ST,''HH:mm:ss'') AS DATETIME), MST.SE) ClassOrder
FROM
(SELECT SC, SN, ID, TR FROM STU WHERE DEL = 0) STU
INNER JOIN (SELECT * FROM CAR WHERE DEL = 0) CAR ON STU.SC = CAR.SC AND STU.SN = CAR.SN
LEFT JOIN (SELECT * FROM CRS WHERE DEL = 0) CRS ON CAR.CN = CRS.CN
INNER JOIN (SELECT * FROM TDAYS WHERE DT < GETDATE() AND HO NOT IN (''@'',''#'',''$'',''*'')) TDAYS ON TDAYS.SC = STU.SC AND TDAYS.Track = STU.TR
LEFT JOIN (SELECT * FROM MST WHERE DEL = 0) MST ON MST.SC = CAR.SC AND MST.SE = CAR.SE
INNER JOIN (SELECT * FROM CCD WHERE DEL = 0) CCD ON MST.CSQ = CCD.CSQ AND CCD.DT = TDAYS.DT
INNER JOIN (SELECT * FROM FTF WHERE DEL = 0) FTF ON MST.FSQ = FTF.SQ
LEFT JOIN (SELECT * FROM APDS WHERE DEL = 0) APDS ON APDS.SC = STU.SC AND APDS.SN = STU.SN 
WHERE STU.SC IN (SELECT CD FROM LOC WHERE DEL = 0 AND E = ''3'')
AND COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy'')) BETWEEN CAR.DS AND CAR.DE --ONLY CURRENT TERMS
AND CCD.DT = COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy''))
) Classes

GROUP BY SC, SN

'

--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)


INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'MSTP', N'MST Classes Pivoted', N'', N'SC,SN', N'STU', N'SC,SN', N'SC,SN', N'One', N'SC,SN,SM,PD,SE', 0, CAST(N'2019-03-01T22:18:43.317' AS DateTime), 1)

INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM1', 1, N'Class 1 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:40.707' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD1', 2, N'Class 1 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:51.777' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE1', 3, N'Class 1 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:59.387' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE1', 4, N'Class 1 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:06.940' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM1', 5, N'Class 1 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:12.173' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN1', 6, N'Class 1 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:08.750' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO1', 7, N'Class 1 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:24.983' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE1', 8, N'Class 1 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:49.463' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM2', 9, N'Class 2 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:16.713' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD2', 10, N'Class 2 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:19.830' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE2', 11, N'Class 2 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:32.807' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE2', 12, N'Class 2 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:37.713' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM2', 13, N'Class 2 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:52.757' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN2', 14, N'Class 2 Couse ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:03.830' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO2', 15, N'Class 2 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:19.397' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE2', 16, N'Class 2 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:40.903' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM3', 17, N'Class 3 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:27:18.273' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD3', 18, N'Class 3 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:47.107' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE3', 19, N'Class 3 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:48.517' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE3', 20, N'Class 3 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:48.933' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM3', 21, N'Class 3 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:53.630' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN3', 22, N'Class 3 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:25.550' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO3', 23, N'Class 3 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:15.153' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE3', 24, N'Class 3 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:53.013' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM4', 25, N'Class 4 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:01.997' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD4', 26, N'Class 4 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:57.170' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE4', 27, N'Class 4 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:53.873' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE4', 28, N'Class 4 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:57.817' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM4', 29, N'Class 4 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:01.507' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN4', 30, N'Class 4 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:32.173' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO4', 31, N'Class 4 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:21.283' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE4', 32, N'Class 4 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:05.837' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM5', 33, N'Class 5 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:43.047' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD5', 34, N'Class 5 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:45.950' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE5', 35, N'Class 5 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:02.743' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE5', 36, N'Class 5 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:04.707' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM5', 37, N'Class 5 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:06.320' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN5', 38, N'Class 5 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:38.940' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO5', 39, N'Class 5 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:27.043' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE5', 40, N'Class 5 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:11.390' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM6', 41, N'Class 6 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:32.273' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD6', 42, N'Class 6 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:36.037' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE6', 43, N'Class 6 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:07.673' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE6', 44, N'Class 6 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:10.240' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM6', 45, N'Class 6 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:15.553' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN6', 46, N'Class 6 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:45.043' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO6', 47, N'Class 6 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:34.550' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE6', 48, N'Class 6 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:21.053' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM7', 49, N'Class 7 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:27:47.813' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD7', 50, N'Class 7 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:11.100' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE7', 51, N'Class 7 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:13.237' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE7', 52, N'Class 7 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:15.607' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM7', 53, N'Class 7 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:22.763' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN7', 54, N'Class 7 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:52.933' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO7', 55, N'Class 7 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:40.650' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE7', 56, N'Class 7 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:30.680' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM8', 57, N'Class 8 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:15.660' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD8', 58, N'Class 8 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:17.790' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE8', 59, N'Class 8 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:20.510' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE8', 60, N'Class 8 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:21.360' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM8', 61, N'Class 8 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:28.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN8', 62, N'Class 8 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:58.493' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO8', 63, N'Class 8 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:50.050' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE8', 64, N'Class 8 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:37.967' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM9', 65, N'Class 9 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:10.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD9', 66, N'Class 9 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:25.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE9', 67, N'Class 9 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:26.683' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE9', 68, N'Class 9 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:26.680' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM9', 69, N'Class 9 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:59.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN9', 70, N'Class 9 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:35:03.623' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO9', 71, N'Class 9 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:37:00.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE9', 72, N'Class 9 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:45.353' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM10', 73, N'Class 10 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:34.657' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD10', 74, N'Class 10 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:32.300' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE10', 75, N'Class 10 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:32.407' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE10', 76, N'Class 10 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:31.787' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM10', 77, N'Class 10 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:06.160' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN10', 78, N'Class 10 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:35:08.913' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO10', 79, N'Class 10 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:37:07.783' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE10', 80, N'Class 10 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:52.823' AS DateTime))

update apds set jod = getdate()
update apds set jod = getdate()

print 'MSTP Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of MSTP blocked by version control - MSTP needs no update or was customized.'
set nocount off


