--PGMS - Program and Authorization Status - Custom View - Aeries Software - Jared Kuszewski
--If you comission a new PGM or AUT code, you will want to drop and recreate to include it - Run line 4 if you wish to drop a prior PGMS rendition
/* 
drop view pgms; delete from ctf where tc = 'PGMS'; delete from ctd where tc = 'PGMS';
*/
--########### SET OPTIONS IN THE NEXT TWO LINES TO BLOCK NSLP STATUS OR SPED INDICATION IN CUSTOM TABLE DEFINITION ###########
declare @HIDE_NSLP BIT = 1 --Specify 0 to unhide the NSLP column in the Custom Table definition. This leaves it available in SQL
declare @HIDE_SpEd BIT = 1 --Specify 0 to unhide the Special Ed column in the Custom Table definition. This leaves it available in SQL
--If you wish to block future updates because you customized this now, specify a date in the far distant future in the next line. Line 4 can override by dropping first.
declare @version varchar(23) = '2022-09-26 16:45:00.000'
--############################################################################################################################
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'PGMS'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'PGMS'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale PGMS view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''PGMS''and o.[type_desc] = ''VIEW'') begin drop view PGMS end; delete from ctf where tc = ''PGMS''; delete from ctd where tc = ''PGMS'';'exec (@DynaQuery)
set @DynaQuery = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@DynaQuery)
set @DynaQuery = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@DynaQuery)
set @DynaQuery = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@DynaQuery)

set @DynaQuery = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))

update apds set jod = getdate()
update apds set jod = getdate()
'
EXEC (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
create view PGMS_descrip as 

WITH EFD --Most Recently Modified Effective Date from APDS.JOD (Just One Day)
(ID, JOD) as
(
SELECT ID, JOD FROM (
SELECT STU.ID, APDS.JOD
, ROW_NUMBER() OVER (PARTITION BY STU.ID ORDER BY STU.ID, STU.DTS DESC) RowNum
FROM STU INNER JOIN APDS 
ON STU.SC = APDS.SC AND STU.SN = APDS.SN 
WHERE APDS.DEL = 0 AND STU.DEL = 0
) D
WHERE RowNum = 1
)

select IDN.ID, 
isnull(
(select top 1 cd 
from fre 
where id = idn.id and esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed is null or eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')))
order by esd desc, sq desc)
,'''' ) as NSL,
isnull((select ''Y'' from cse where id = idn.id and di <> '''' and xd is null and del = 0),'''') SPD,
coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) EFD,
' 
select @DynaQuery += N'
case 
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (psd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (ped >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or ped is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Eligible''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and esd is null and psd is null and pid = idn.id and del = 0) then ''Null Start''
else ''''
end as ''PGM_'  + cd + N''' --PGM_CODE as Header
--end as '''  + left(de,128) + N''' --Description as Header
,' 
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') as de from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0 and ST = (select ST from loc where cd = 0)
union
select cd, replace(replace(de,'''',''''''),' ','_') as de from COD where tc = 'pgm' and fc = 'cd' and del = 0 and cd not in (select cd from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0)) codes where de not like '%no longer%' and de not like '%old code%' and cd <> ''

--and cd in ('122','131','135','190') --Even though this query builds an evaluation of all PGM codes with values, use this line to keep it simple and only select the codes you want
and cd in (select distinct pgm.cd from stu inner join pgm on stu.id = pgm.pid where stu.del = 0 
and (pgm.psd > CURRENT_TIMESTAMP - 2000 or pgm.esd > CURRENT_TIMESTAMP - 2000) --Only incude programs you still populate in a sensible timeframe.
and stu.tg = '' --remark this line out when evaluating historic programs no active students participate in
and pgm.cd <> '')


) PGMcodes order by cd

--Check to see if AUT codes are defined before attempting to run
if exists (select top 1 1 from (select cd, de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students
and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
)

begin --Transaction to evaluate AUT codes since they exist

select @DynaQuery += '
case 
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Conflict''
when idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''No''
else ''''
end as ''AUT_' + cd + ''' --AUT_CD  as header
,'
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students

--and cd in ('A','B') --Even though this query builds an evaluation of all AUT codes, use this line to keep it simple and only select the codes you want

and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
) AUTcodes order by cd

set @DynaQuery = left(@DynaQuery, len(@DynaQuery) - 1) -- remove the final comma  since we can't have a trailing comma before the FROM as there are no new dynamic columns

end --Transaction to evaluate AUT codes since they exist

set @DynaQuery = left(@DynaQuery, len(@DynaQuery) - 1) -- remove the final comma  since we can't have a trailing comma before the FROM as there are no new dynamic columns

select @DynaQuery += N'
,idn.del, idn.dts
from idn 
left join efd on idn.id = efd.id
where idn.del = 0

'

--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)


insert CTD (TC, NM, NLC, PKF, PT, PF, CF, OM, OB, VW)
select 'PGMS','Program and Authorization Status','Student Data','ID','STU','ID','ID','One','ID','1'

insert ctf (TC, FC, SQ, NM, TY, DL)
select 'PGMS' TC, COLUMN_NAME FC, row_number() over (order by ordinal_position ) * 2 -1 SQ,
case when COLUMN_NAME = 'ID' then 'PermID'
when COLUMN_NAME = 'NSL' then 'NSLP_Code'
when COLUMN_NAME = 'SPD' then 'Special_Ed'
when COLUMN_NAME = 'EFD' then 'Effective Date'
when left(COLUMN_NAME, 4) in ('PGM_','AUT_') then 
(select top 1 LEFT(DE,128)  from 
(select de from USYSGCOD where tc = left(COLUMN_NAME, 3) and fc = 'cd'  and cd = substring(COLUMN_NAME,charindex('_',COLUMN_NAME) + 1,255) and del = 0  and ST = (select ST from loc where cd = 0)
union
select de from COD where tc = left(COLUMN_NAME, 3) and fc = 'cd'  and cd = substring(COLUMN_NAME,charindex('_',COLUMN_NAME) + 1,255) and del = 0) codes)
else '' end NM,
case 
when right(DATA_TYPE, 3) like 'INT' then 'Number' 
when right(DATA_TYPE, 4) like 'CHAR' then 'Text'
else '' end TY, 
'600' DL
from INFORMATION_SCHEMA.columns 
where TABLE_NAME = 'pgms_descrip'
and COLUMN_NAME not in ('id','del','dts')
and COLUMN_NAME <> CASE WHEN @HIDE_NSLP = 1 THEN 'NSL' ELSE '' END
and COLUMN_NAME <> CASE WHEN @HIDE_SpEd = 1 THEN 'SPD' ELSE '' END


insert CTF (TC, FC, SQ)
select top (select count(*) - 1 from ctf where tc = 'PGMS') 
'PGMS' TC, FC = 'NEWLINE' + cast(row_number() over (order by sq) as varchar(4)),
sq + 1 SQ
from ctf where tc = 'PGMS'

drop view PGMS_Descrip


set @DynaQuery = N''

select @DynaQuery += N'
create view PGMS as 
--PGMS - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
--Remove Aeries Soft or make the version a far newer date in the line preceeding this if you wish to block updates by version control if you customize this view to your liking
WITH EFD --Most Recently Modified Effective Date from APDS.JOD (Just One Day)
(ID, JOD) as
(
SELECT ID, JOD FROM (
SELECT STU.ID, APDS.JOD
, ROW_NUMBER() OVER (PARTITION BY STU.ID ORDER BY STU.ID, STU.DTS DESC) RowNum
FROM STU INNER JOIN APDS 
ON STU.SC = APDS.SC AND STU.SN = APDS.SN 
WHERE APDS.DEL = 0 AND STU.DEL = 0
) D
WHERE RowNum = 1
)

select IDN.ID,  
isnull(
(select top 1 cd 
from fre 
where id = idn.id and esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed is null or eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')))
order by esd desc, sq desc)
,'''' ) as NSL,
isnull((select ''Y'' from cse where id = idn.id and di <> '''' and xd is null and del = 0),'''') SPD,
coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) EFD,
' 
select @DynaQuery += N'
case 
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (psd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (ped >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or ped is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Eligible''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and esd is null and psd is null and pid = idn.id and del = 0) then ''Null Start''
else ''''
end as ''P' + cast(ROW_NUMBER() over (order by cd) as varchar(3)) + N''' --PGM code Header
,' 
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') as de from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0 and ST = (select ST from loc where cd = 0)
union
select cd, replace(replace(de,'''',''''''),' ','_') as de from COD where tc = 'pgm' and fc = 'cd' and del = 0 and cd not in (select cd from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0 and ST = (select ST from loc where cd = 0))) codes where de not like '%no longer%' and de not like '%old code%' and cd <> ''

--and cd in ('122','131','135','190') --Even though this query builds an evaluation of all PGM codes with values, use this line to keep it simple and only select the codes you want
and cd in (select distinct pgm.cd from stu inner join pgm on stu.id = pgm.pid where stu.del = 0 
and (pgm.psd > CURRENT_TIMESTAMP - 2000 or pgm.esd > CURRENT_TIMESTAMP - 2000) --Only incude programs you still populate in a sensible timeframe.
and stu.tg = '' --remark this line out when evaluating historic programs no active students participate in
and pgm.cd <> '')


) PGMcodes order by cd

--Check to see if AUT codes are defined before attempting to run
if exists (select top 1 1 from (select cd, de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students
and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
)

begin --Transaction to evaluate AUT codes since they exist

select @DynaQuery += '
case 
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Conflict''
when idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''No''
else ''''
end as [A' + cast(ROW_NUMBER() over (order by cd) as varchar(3)) + '] --AUT code header
,'
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students

--and cd in ('A','B') --Even though this query builds an evaluation of all AUT codes, use this line to keep it simple and only select the codes you want

and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
) AUTcodes order by cd

end --Transaction to evaluate AUT codes since they exist

set @DynaQuery = left(@DynaQuery, len(@DynaQuery) - 1) -- remove the final comma  since we can't have a trailing comma before the FROM as there are no new dynamic columns

select @DynaQuery += N'
,idn.del, idn.dts
from idn 
left join efd on idn.id = efd.id
where idn.del = 0

'

--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)

update CTF
set FC = NEWFC
from ctf inner join (select sq, 
case when fc like 'PGM_%' then 'P' + cast(ROW_NUMBER() over (order by sq) as varchar(3)) end NEWFC
from ctf
where tc = 'pgms' and fc like 'PGM_%') c
on ctf.sq = c.sq
where tc = 'pgms' and fc like 'PGM_%'

update CTF
set FC = NEWFC
from ctf inner join (select sq, 
case when fc like 'AUT_%' then 'A' + cast(ROW_NUMBER() over (order by sq) as varchar(3)) end NEWFC
from ctf
where tc = 'pgms' and fc like 'AUT_%') c
on ctf.sq = c.sq
where tc = 'pgms' and fc like 'AUT_%'

update ctf set TY = 'Date' where tc = 'PGMS' and FC = 'EFD'

print 'PGMS Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of PGMS blocked by version control - PGMS needs no update or was customized'
set nocount off

