--All Custom Objects 2020-03-06

--APBP - Attendance Percentage by Period - Custom View - Aeries Software - Jared Kuszewski
--Create APBP Custom View if not present - Run line 4 if you wish to drop a prior APBP rendition before I added version control
/* 
drop view APBP; delete from ctf where tc = 'APBP'; delete from ctd where tc = 'APBP';
*/
declare @version varchar(23) = '2022-09-26 16:45:00.000'
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'APBP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > --your version here
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'APBP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale APBP view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''APBP''and o.[type_desc] = ''VIEW'') begin drop view APBP end; delete from ctf where tc = ''APBP''; delete from ctd where tc = ''APBP'';'
exec (@DynaQuery)
set @DynaQuery = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@DynaQuery)
set @DynaQuery = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@DynaQuery)
set @DynaQuery = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@DynaQuery)


set @DynaQuery = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))

update apds set jod = getdate()
update apds set jod = getdate()
'
EXEC (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
--APBP (Attendance Percentage by Period) custom view - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
CREATE VIEW APBP AS

WITH D 
(SC, DY, DT, HO, MO, BL, AB, DW, BL0, BL1, BL2, BL3, BL4, BL5, BL6, BL7, BL8, BL9)
as 
(
SELECT SC, DY, DT, HO, MO, BL, AB,
DATEPART(DW,DT) DW, 
CASE WHEN LEFT(BL,1) = ''0'' THEN 1 ELSE 0 END BL0,
CASE WHEN SUBSTRING(BL,2,1) = ''1'' THEN 1 ELSE 0 END BL1,
CASE WHEN SUBSTRING(BL,3,1) = ''2'' THEN 1 ELSE 0 END BL2,
CASE WHEN SUBSTRING(BL,4,1) = ''3'' THEN 1 ELSE 0 END BL3,
CASE WHEN SUBSTRING(BL,5,1) = ''4'' THEN 1 ELSE 0 END BL4,
CASE WHEN SUBSTRING(BL,6,1) = ''5'' THEN 1 ELSE 0 END BL5,
CASE WHEN SUBSTRING(BL,7,1) = ''6'' THEN 1 ELSE 0 END BL6,
CASE WHEN SUBSTRING(BL,8,1) = ''7'' THEN 1 ELSE 0 END BL7,
CASE WHEN SUBSTRING(BL,9,1) = ''8'' THEN 1 ELSE 0 END BL8,
CASE WHEN SUBSTRING(BL,10,1) = ''9'' THEN 1 ELSE 0 END BL9
FROM [DAY] WHERE DEL = 0
)

SELECT 
COUNTS.SC, 
COUNTS.SN, 
1 SQ,
CONVERT(VARCHAR(10),MIN(COUNTS.DT),101) DS, 
CONVERT(VARCHAR(10),MAX(COUNTS.DT),101) DE, 
COUNTS.SE, 
MST.SM,
MST.PD,
CRS.CO, 
TCH.TE,
MST.DY,
CRS.S1,
CRS.DC,
SUM(EnrolledInCAR) EIC, 
SUM(DaysAbsent) DAB, 
SUM(DaysTardy) DTY, 
SUM(TempNotEnrolled) TNE,
LEFT(100 - cast(SUM(DaysAbsent) as dec(12,4))/(SUM(EnrolledInCAR) - SUM(TempNotEnrolled))*100,6) PRS, --PresentPercent
LEFT(100 -  cast(SUM(DaysTardy) as dec(12,4))/(SUM(EnrolledInCAR) - SUM(DaysAbsent) - SUM(TempNotEnrolled))*100,6) PNC, --PunctualPercent
0 DEL,
CURRENT_TIMESTAMP DTS
FROM (

SELECT distinct
C.SC, C.SN, D.DT, M.SE
,1 EnrolledInCAR
,isnull((select A from(
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 0 and a0 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 1 and a1 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 2 and a2 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 3 and a3 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 4 and a4 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 5 and a5 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 6 and a6 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 7 and a7 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 8 and a8 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 9 and a9 in (select cd from abs where del = 0 and ad = 0 and sc = att.sc))) p)
,0) DaysAbsent
,isnull((select A from(
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 0 and a0 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 1 and a1 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 2 and a2 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 3 and a3 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 4 and a4 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 5 and a5 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 6 and a6 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 7 and a7 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 8 and a8 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 9 and a9 in (select cd from abs where del = 0 and ty in (''5'',''8'',''9'') and sc = att.sc))) p)
,0) DaysTardy
,isnull((select A from(
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 0 and a0 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 1 and a1 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 2 and a2 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 3 and a3 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 4 and a4 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 5 and a5 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 6 and a6 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 7 and a7 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 8 and a8 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc)) union
(select 1 a from att where del = 0 and sc = c.sc and sn = c.sn and dt = D.DT and m.pd = 9 and a9 in (select cd from abs where del = 0 and ne = 1 and sc = att.sc))) p)
,0) TempNotEnrolled

FROM
LOC L INNER JOIN CAR C ON L.CD = C.SC
INNER JOIN D ON D.SC = C.SC
INNER JOIN MST M ON C.SC = M.SC AND C.SE = M.SE
LEFT JOIN APDS ON C.SC = APDS.SC AND C.SN = APDS.SN
WHERE C.DEL = 0 and D.DT >= C.DS AND (D.DT <= C.DE OR C.DE IS NULL)
AND D.DT BETWEEN COALESCE(APDS.SWH,''1/1/1900'') AND COALESCE(APDS.TWH,''12/31/9999'')
AND D.HO NOT IN (''@'',''#'',''$'')
AND L.K < 1 --NoTracks
AND D.DT < CURRENT_TIMESTAMP --Do not count the future
AND 1 =
CASE WHEN
CASE 
WHEN L.AB = 1 AND M.DY = ''A-DAYS'' AND D.AB = ''A'' THEN 1
WHEN L.AB = 1 AND M.DY = ''B-DAYS'' AND D.AB = ''B'' THEN 1
WHEN M.PD = 0 AND D.BL0 = 1 THEN 1
WHEN M.PD = 1 AND D.BL1 = 1 THEN 1
WHEN M.PD = 2 AND D.BL2 = 1 THEN 1
WHEN M.PD = 3 AND D.BL3 = 1 THEN 1
WHEN M.PD = 4 AND D.BL4 = 1 THEN 1
WHEN M.PD = 5 AND D.BL5 = 1 THEN 1
WHEN M.PD = 6 AND D.BL6 = 1 THEN 1
WHEN M.PD = 7 AND D.BL7 = 1 THEN 1
WHEN M.PD = 8 AND D.BL8 = 1 THEN 1
WHEN M.PD = 9 AND D.BL9 = 1 THEN 1
WHEN D.BL = '''' THEN 1
ELSE 0 
END = 1 
AND
CASE 
WHEN D.DW = 2 AND M.MM = 1 THEN 1
WHEN D.DW = 3 AND M.MT = 1 THEN 1
WHEN D.DW = 4 AND M.MW = 1 THEN 1
WHEN D.DW = 5 AND M.MR = 1 THEN 1
WHEN D.DW = 6 AND M.MF = 1 THEN 1
ELSE 0 
END = 1
AND 
CASE WHEN
C.SN IN (SELECT SN FROM ENR WHERE SC = C.SC AND SN = C.SN AND DEL = 0 
AND RIGHT(YR,2) = SUBSTRING(DB_NAME(),4,2) 
AND D.DT >= C.DS AND (D.DT <= C.DE OR C.DE IS NULL))
THEN 1 
ELSE 0
END = 1
THEN 1
ELSE 0
END 

) COUNTS
INNER JOIN MST ON COUNTS.SC = MST.SC AND COUNTS.SE = MST.SE
INNER JOIN TCH ON MST.SC = TCH.SC AND MST.TN = TCH.TN
INNER JOIN CRS ON MST.CN = CRS.CN

GROUP BY COUNTS.SC, COUNTS.SN, COUNTS.SE, MST.SM, MST.PD, CRS.CO, TCH.TE, MST.DY, CRS.S1, CRS.DC
HAVING (SUM(EnrolledInCAR) - SUM(DaysAbsent) - SUM(TempNotEnrolled)) > 0
AND (SUM(EnrolledInCAR) - SUM(TempNotEnrolled)) > 0
'
exec (@DynaQuery)

INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'APBP', N'Attendance Percentage by Period', N'Student Data', N'SC,SN,SQ', N'STU', N'SC,SN', N'SC,SN', N'Many', N'SC,SN,PD,DS', 0, CAST(N'2018-10-04T13:22:37.670' AS DateTime), 1);
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'CO', 10, N'CourseTitle', N'Text', 150, 0, 0, 0, CAST(N'2018-10-03T20:23:51.577' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DAB', 16, N'DaysAbsent', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:27:04.103' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DC', 14, N'Dept', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:25:39.737' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DE', 6, N'DateEnded', N'Date', 120, 0, 0, 0, CAST(N'2018-10-03T20:24:00.970' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DS', 5, N'DateStarted', N'Date', 120, 0, 0, 0, CAST(N'2018-10-03T20:21:39.420' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DTY', 17, N'DaysTardy', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:27:23.657' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'DY', 12, N'Meets', N'Text', 60, 0, 0, 0, CAST(N'2018-10-03T20:24:54.590' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'EIC', 15, N'EnrolledDays', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:26:38.143' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'NEWLINE1', 0, N'', N'', 0, 0, 0, 1, CAST(N'2018-10-03T20:21:48.860' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'NEWLINE2', 0, N'', N'', 0, 0, 0, 1, CAST(N'2018-10-03T20:21:52.767' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'PD', 9, N'Period', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:23:24.920' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'PNC', 20, N'PunctualPercentage', N'Text', 70, 0, 0, 0, CAST(N'2018-10-04T13:58:51.253' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'PRS', 19, N'PresentPercentage', N'Text', 70, 0, 0, 0, CAST(N'2018-10-03T20:28:26.853' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'S1', 13, N'GradReq', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:25:18.963' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SC', 1, N'SchoolCode', N'Text', 50, 0, 0, 0, CAST(N'2018-10-03T20:20:21.003' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SE', 7, N'Section', N'Text', 100, 0, 0, 0, CAST(N'2018-10-03T20:22:41.093' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SM', 8, N'Term', N'Text', 15, 0, 0, 0, CAST(N'2018-10-03T20:23:02.940' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'SN', 3, N'StudentNumber', N'Text', 100, 0, 0, 0, CAST(N'2018-10-03T20:20:54.913' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'TE', 11, N'Teacher', N'Text', 300, 0, 0, 0, CAST(N'2018-10-03T20:24:18.960' AS DateTime));
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'APBP', N'TNE', 18, N'TempNotEnrolled', N'Text', 30, 0, 0, 0, CAST(N'2018-10-03T20:27:42.390' AS DateTime))

print 'APBP Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of APBP blocked by version control - APBP needs no update or was customized'
set nocount off
GO

--APDR - Attendance Percentage by Date Range - Custom View 
--APDS - Attendance Percentage Date Settings - Custom Table for option parameters used by APDR - Aeries Software - Jared Kuszewski
--Run line five to remove these if you wish
/* 
drop view APDR; delete from ctf where tc = 'APDR'; delete from ctd where tc = 'APDR'; drop table APDS delete from ctf where tc = 'APDS'; delete from ctd where tc = 'APDS';
*/
--############################################################################################################################
--If you wish to block future updates because you customized this now, specify a date in the far distant future in the next line. Line 5 can override by dropping first.
declare @version varchar(23) = '2022-09-26 16:45:00.000'
--############################################################################################################################
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'APDR'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'APDR'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale APDR view and APDS table if stale and recreate it
declare @SQL nvarchar(max) = N''
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDR''and o.[type_desc] = ''VIEW'') begin drop view APDR; delete from ctf where tc = ''APDR''; delete from ctd where tc = ''APDR''; end' exec (@SQL)
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@SQL)
set @SQL = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@SQL)
set @SQL = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@SQL)
set @SQL = N'

create view APDR as 
--APDR - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
--Remove Aeries Soft or make the version a far newer date in the line preceeding this if you wish to block updates by version control if you customize this view to your liking
--Days Enrolled, Days Present, Days Absent, ATT percentage, and tardies aggregated by school this DB year with custom date range at top
--Now Honors Tracks!

--Unpivotted Tracks from DAY in a CTE called tdays

with tdays (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
''A''+T1 as T1, 
''B''+T2 as T2, 
''C''+T3 as T3, 
''D''+T4 as T4, 
''E''+T5 as T5, 
''F''+T6 as T6, 
''G''+T7 as T7, 
''H''+T8 as T8, 
''I''+T9 as T9, 
''J''+T10 as T10, 
''K''+T11 as T11, 
''L''+T12 as T12, 
''M''+T13 as T13, 
''N''+T14 as T14, 
''O''+T15 as T15, 
''P''+T16 as T16, 
''Q''+T17 as T17, 
''R''+T18 as T18, 
''S''+T19 as T19, 
''T''+T20 as T20, 
''U''+T21 as T21, 
''V''+T22 as T22, 
''W''+T23 as T23, 
''X''+T24 as T24, 
''Y''+T25 as T25, 
''Z''+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv

union

select SC, DY, DT, AB, HO, BL, '' '' + HO AS TrackHO from day where DEL = 0
) trackdays
)




select 
(select convert(varchar(10),swh,101) from APDS where sc = dedpda.sc and sn = dedpda.sn) SWH, --[APDS Begining Range]
(select case when twh > getdate() then convert(varchar(10),getdate(),101) else convert(varchar(10),twh,101) end from APDS where sc = dedpda.sc and sn = dedpda.sn) TWH, --[APDS Ending Range or Today]
SC, ID, SN, LN, FN, YR,
[Days Enrolled] - [Days Not Enrolled] DE, 
[Days Not Enrolled] NE, 
[Days Enrolled] - [Days Not Enrolled] - [days Absent] as DP, --[days Present]
[days Absent] DA, 
[days Made Up] DMU, 
case when [Days Enrolled] <> 0 then cast(cast( ([Days Enrolled] - [Days Not Enrolled] - [days Absent] + [days Made Up]) / cast([Days Enrolled] - [Days Not Enrolled] as dec(10,3)) * 100 as float) as varchar(50)) + ''%'' 
else '''' end as APR, --ATTPercentage
Tardies TAR 
,0 DEL
,getdate() DTS
from 
(
select SC, ID, SN, LN, FN, YR, sum([Days Enrolled]) as [Days Enrolled], sum([Days Not Enrolled]) as [Days Not Enrolled], sum([days Absent]) as [days Absent], sum([days Made Up]) as [days Made UP], sum(Tardies) as Tardies from 
(select 
stu.sc, stu.id, stu.sn, stu.ln, stu.fn,
enr.yr, enr.pr, enr.ED, enr.LD,


(select count(*) from tdays inner join enr as enr2 on tdays.dt >= enr2.ed
where ho not in (''@'',''#'',''$'',''*'')  
and enr2.sc = [tdays].sc
and [tdays].sc = stu.sc
and enr2.id = stu.id
and enr2.yr = ''20'' + substring(db_name(),4,2)
and [tdays].dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) end
and [tdays].dt >= case when (select swh from APDS where sc = enr2.sc and sn = enr2.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = enr2.sc and sn = enr2.sn) end
and [tdays].dt <= case when enr2.ld is not null then enr2.ld else case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = enr2.sc and sn = enr2.sn) end end
and enr2.del = 0 
and [tdays].dt >= enr.ed and [tdays].dt <= (case when enr.ld is not null then enr.ld else [tdays].dt end)
and enr2.sc = stu.sc
and tdays.track = stu.tr
) as [Days Enrolled],

(select count(*) from att where del = 0 and al in (select cd from [abs] where del = 0 and sc = stu.sc and ad <> 1 and ne <> 1) and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as [days Absent],

(select count(*) from att where del = 0 and ada > '''' and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as [days Made Up],

(select count(*) from att where AL in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a0 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a1 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a2 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a3 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a4 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a5 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a6 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a7 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a8 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) + 
(select count(*) from att where a9 in (select cd from [abs] where ty in (5,8,9) and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as Tardies

,(select count(*) from att where AL in (select cd from [abs] where ne = 1 and del = 0 and sc = att.sc) and del = 0 and sc = stu.sc and sn = stu.sn and att.dt >= enr.ed and att.dt <= (case when enr.ld is not null then enr.ld else att.dt end) and att.dt <= case when (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) is null then getdate() else (select case when twh > getdate() then getdate() else twh end from APDS where sc = att.sc and sn = att.sn) end and att.dt >= case when (select swh from APDS where sc = att.sc and sn = att.sn) is null then ''1/1/1900'' else (select swh from APDS where sc = att.sc and sn = att.sn) end and att.dt in (select dt from tdays where ho not in (''@'',''#'',''$'',''*'') and tdays.track = (select tr from stu where sc = att.sc and sn = att.sn))) as [Days Not Enrolled]
from stu inner join enr on stu.id = enr.id and stu.sc = enr.sc
where right(enr.yr,2) = substring(db_name(),4,2)
and stu.del = 0 and enr.del = 0

) deda

WHERE [Days Enrolled] > 0
group by SC, ID, SN, LN, FN, YR) dedpda
' exec(@SQL)
set @SQL = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDR'', N''Attendance Percentage by Date Range'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:42:50.370'' AS DateTime), 1)
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''SWH'', 1, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-23T08:54:21.077'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''TWH'', 2, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-23T08:54:43.180'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DE'', 9, N''Days Enrolled'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:04:28.747'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''NE'', 10, N''Days Not Enrolled'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:04:41.347'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DP'', 11, N''Days Present'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:05:33.237'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DA'', 12, N''Days Absent'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:05:48.460'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''DMU'', 13, N''Days Made Up'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:06:00.750'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''APR'', 14, N''Attendance Percentage'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:06:00.750'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDR'', N''TAR'', 15, N''Tardies'', N''Text'', 300, 0, 0, 0, CAST(N''2019-09-23T09:06:07.747'' AS DateTime))
'
EXEC (@SQL)

set @SQL = N'INSERT APDS (SC, SN) select top 1 sc, sn from stu where del = 0'
EXEC (@SQL)

print 'APDS and APDR Custom Table and View Created or Refreshed!'
set nocount off
END

else print 'Update of APDS and APDR blocked by version control - APDS and APDR need no update or were customized'
set nocount off
GO

--APFP - Attendance Percentage by Flex Period - Custom View 
--APFS - Attendance Percentage by Flex Summary - Custom View 
--APDS - Attendance Percentage Date Settings - Custom Table for option parameters used by APFP - Aeries Software - Jared Kuszewski
--Run line six to remove these if you wish
/* 
drop view APFS; delete from ctf where tc = 'APFS'; delete from ctd where tc = 'APFS'; drop view APFP; delete from ctf where tc = 'APFP'; delete from ctd where tc = 'APFP'; drop table APDS; delete from ctf where tc = 'APDS'; delete from ctd where tc = 'APDS';
*/
--############################################################################################################################
--If you wish to block future updates because you customized this now, specify a date in the far distant future in the next line. Line 5 can override by dropping first.
declare @version varchar(23) = '2022-09-26 16:45:00.000'
--############################################################################################################################
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'APFP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'APFP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale APFP/APFS views and APDS table if stale and recreate it
declare @SQL nvarchar(max) = N''
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APFS''and o.[type_desc] = ''VIEW'') begin drop view APFS; delete from ctf where tc = ''APFS''; delete from ctd where tc = ''APFS''; end' exec (@SQL)
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APFP''and o.[type_desc] = ''VIEW'') begin drop view APFP; delete from ctf where tc = ''APFP''; delete from ctd where tc = ''APFP''; end' exec (@SQL)
set @SQL = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@SQL)
set @SQL = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@SQL)
set @SQL = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@SQL)
set @SQL = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@SQL)


set @SQL = N'create view APFP as 
--APFP - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
WITH TDAYS (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
''A''+T1 as T1, 
''B''+T2 as T2, 
''C''+T3 as T3, 
''D''+T4 as T4, 
''E''+T5 as T5, 
''F''+T6 as T6, 
''G''+T7 as T7, 
''H''+T8 as T8, 
''I''+T9 as T9, 
''J''+T10 as T10, 
''K''+T11 as T11, 
''L''+T12 as T12, 
''M''+T13 as T13, 
''N''+T14 as T14, 
''O''+T15 as T15, 
''P''+T16 as T16, 
''Q''+T17 as T17, 
''R''+T18 as T18, 
''S''+T19 as T19, 
''T''+T20 as T20, 
''U''+T21 as T21, 
''V''+T22 as T22, 
''W''+T23 as T23, 
''X''+T24 as T24, 
''Y''+T25 as T25, 
''Z''+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv

union 
select SC, DY, DT, AB, HO, BL, '' '' + HO AS TrackHO from day where DEL = 0
) trackdays
)

SELECT SC, SN, SE, CN, CO, DC, S1 GRQ
,(SELECT STI FROM FTF WHERE B.FSQ = SQ AND SC = B.SC AND DEL = 0) STI
,(SELECT DE FROM FTF WHERE B.FSQ = SQ AND SC = B.SC AND DEL = 0) PDE
,
STUFF(
(SELECT  '' | '',STF.FN + '' '' + STF.LN
FROM SSE 
INNER JOIN STF ON SSE.ID = STF.ID
WHERE SSE.DEL = 0 AND STF.DEL = 0 AND SSE.TG = '''' 
AND TWH BETWEEN
COALESCE(SD,''1/1/1900'')
AND
COALESCE(ED,''12/31/9999'')
AND SSE.SC = B.SC AND SSE.SE = B.SE
ORDER BY PR DESC, SD
FOR XML PATH (''''))
, 1, 3, '''') TE
, ENR, DA, ENR - DA DP, TRD, DNE
, CASE WHEN ENR - DA > 0 and ENR - DA > 0 THEN LEFT((ENR - DA) / (ENR * 1.0) * 100,6) ELSE ''0'' END + ''%'' PRC
, SWH, TWH, 1 SQ, 0 DEL, GETDATE() DTS
FROM (
SELECT SC, SN, SE, CN, CO, DC, S1, FSQ
,SUM(ENR) ENR
,SUM(DA) DA
,SUM(TRD) TRD
,SUM(DNE) DNE
, SWH, TWH
FROM(
SELECT STU.SC, STU.SN
,CAR.SE
,CAR.CN
,CRS.CO
,CRS.DC
,CRS.S1
,MST.FSQ
,1 ENR
,CASE WHEN CAT.AC IN (SELECT CD FROM ABS WHERE DEL = 0 AND AD = 0 AND SC = STU.SC) THEN 1 ELSE 0 END DA
,CASE WHEN CAT.AC IN (SELECT CD FROM ABS WHERE DEL = 0 AND TY IN (''5'',''8'',''9'') AND SC = STU.SC) THEN 1 ELSE 0 END TRD
,CASE WHEN CAT.AC IN (SELECT CD FROM ABS WHERE DEL = 0 AND NE = 1 AND SC = STU.SC) THEN 1 ELSE 0 END DNE
,CASE WHEN COALESCE(APDS.SWH,''1/1/1900'') > CAR.DS THEN APDS.SWH ELSE CAR.DS END SWH
,CASE 
WHEN GETDATE() <  COALESCE(APDS.TWH,''12/31/9999'') AND GETDATE() < CAR.DE THEN GETDATE()
WHEN COALESCE(APDS.TWH,''12/31/9999'') < CAR.DE THEN APDS.TWH
ELSE CAR.DE END TWH

FROM 
(SELECT SC, SN, ID, TR FROM STU WHERE DEL = 0) STU
INNER JOIN (SELECT * FROM CAR WHERE DEL = 0) CAR ON STU.SC = CAR.SC AND STU.SN = CAR.SN
LEFT JOIN (SELECT * FROM CRS WHERE DEL = 0) CRS ON CAR.CN = CRS.CN
INNER JOIN (SELECT * FROM TDAYS WHERE DT < GETDATE() AND HO NOT IN (''@'',''#'',''$'',''*'')) TDAYS ON TDAYS.SC = STU.SC AND TDAYS.Track = STU.TR
LEFT JOIN (SELECT * FROM MST WHERE DEL = 0) MST ON MST.SC = CAR.SC AND MST.SE = CAR.SE
INNER JOIN (SELECT * FROM CCD WHERE DEL = 0) CCD ON MST.CSQ = CCD.CSQ AND CCD.DT = TDAYS.DT
LEFT JOIN (SELECT * FROM CAT WHERE DEL = 0) CAT ON CAT.SCL = STU.SC AND CAT.ID = STU.ID AND CAT.SE = CAR.SE AND CAT.DT = TDAYS.DT 
LEFT JOIN (SELECT * FROM APDS WHERE DEL = 0) APDS ON APDS.SC = STU.SC AND APDS.SN = STU.SN 
WHERE
STU.SC IN (SELECT DISTINCT SC FROM CAR WHERE DEL = 0)
AND STU.SC IN (SELECT DISTINCT SC FROM FTF WHERE DEL = 0)
AND TDAYS.DT BETWEEN CAR.DS AND CAR.DE
AND TDAYS.DT BETWEEN 
CASE WHEN COALESCE(APDS.SWH,''1/1/1900'') > CAR.DS THEN APDS.SWH ELSE CAR.DS END 
AND 
CASE WHEN COALESCE(APDS.TWH,''12/31/9999'') < CAR.DE THEN APDS.TWH ELSE CAR.DE END

--AND STU.SC = 41
--AND STU.SN = 1576

) A
GROUP BY SC, SN, SE, CN, CO, DC, S1, FSQ, SWH, TWH
) B
' exec(@SQL)

set @SQL = N'create view APFS as 
--APFS - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
SELECT SC, SN, ENR, DP, 
CASE WHEN DP > 0 THEN CAST(CAST(((DP * 1.0) / ENR) * 100 AS DEC (12,2)) AS VARCHAR(20)) + ''%'' ELSE '''' END AS PRC,
DEL, DTS from 
(
SELECT SC, SN, SUM(ENR) ENR, SUM(DP) DP, 0 DEL, GETDATE() DTS
FROM APFP
GROUP BY SC, SN
) A
' exec(@SQL)

set @SQL = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [VW], [DEL], [DTS]) VALUES (N''APFP'', N''Attendance Percentage by Flex Period'', N''Student Data'', N''SC,SN,SQ'', N''STU'', N''SC,SN'', N''SC,SN'', N''Many'', N''SC,SN,STI,CN'', 1, 0, CAST(N''2021-10-27T13:37:04.807'' AS DateTime))
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [VW], [DEL], [DTS]) VALUES (N''APFS'', N''Attendance Percentage by Flex Summary'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 1, 0, CAST(N''2021-12-08T08:04:39.333'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''CN'', 2, N''Course Number'', N''Text'', 70, 0, 0, 0, CAST(N''2021-10-27T13:40:09.230'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''CO'', 3, N''Course Title'', N''Text'', 170, 0, 0, 0, CAST(N''2021-10-27T13:40:35.570'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DA'', 15, N''Days Absent'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DC'', 4, N''Dept Code'', N''Text'', 50, 0, 0, 0, CAST(N''2021-10-27T13:41:21.680'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DNE'', 18, N''Days Not Enrolled'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.857'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''DP'', 16, N''Days Present'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''ENR'', 14, N''Enrolled Days'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''GRQ'', 5, N''Grad Req 1'', N''Text'', 60, 0, 0, 0, CAST(N''2021-10-27T19:47:47.423'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''NEWLINE1'', 6, N'''', N'''', 0, 0, 0, 0, CAST(N''2021-10-27T13:42:01.837'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''NEWLINE2'', 13, N'''', N'''', 0, 0, 0, 0, CAST(N''2021-10-27T19:48:46.843'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''NEWLINE3'', 8, N'''', N'''', 0, 0, 0, 0, CAST(N''2021-10-27T19:48:46.810'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''PDE'', 12, N''Period Desc'', N''Text'', 150, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''PRC'', 19, N''Att Percentage'', N''Text'', 80, 0, 0, 0, CAST(N''2021-10-27T19:48:46.857'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''SE'', 1, N''Section'', N''Text'', 50, 0, 0, 0, CAST(N''2021-10-27T13:39:36.667'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''STI'', 11, N''Period'', N''Text'', 70, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''SWH'', 9, N''Since When'', N''Date'', 120, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''TE'', 7, N''Teacher(s)'', N''Text'', 600, 0, 0, 0, CAST(N''2021-10-27T19:48:46.810'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''TRD'', 17, N''Tardy'', N''Number'', 30, 0, 0, 0, CAST(N''2021-10-27T19:48:46.857'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFP'', N''TWH'', 10, N''Till When'', N''Date'', 120, 0, 0, 0, CAST(N''2021-10-27T19:48:46.827'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFS'', N''DP'', 4, N''Sum of Periods Present'', N''Number'', 40, 0, 0, 0, CAST(N''2021-12-08T08:07:25.297'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFS'', N''ENR'', 3, N''Sum of Enrolled Periods'', N''Number'', 40, 0, 0, 0, CAST(N''2021-12-08T08:06:53.507'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APFS'', N''PRC'', 5, N''Percent Attended'', N''Text'', 100, 0, 0, 0, CAST(N''2021-12-08T08:08:08.843'' AS DateTime))
'
EXEC (@SQL)

set @SQL = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
'
EXEC (@SQL)

set @SQL = N'INSERT APDS (SC, SN) select top 1 sc, sn from stu where del = 0'
EXEC (@SQL)

print 'APDS and APFP/APFS Custom Table and Views Created or Refreshed!'
set nocount off
END

else print 'Update of APDS and APFP/APFS blocked by version control - APDS and APFP/APFS need no update or were customized'
set nocount off
GO

--CONP - Pivoted View of up to 6 most appropriate Emergency contacts - Custom View - Aeries Software - Jared Kuszewski
--(CON.OR sort order is used while using "Lives With", "Access to Portal", "Ed Rights Holder", and "Primary Contact" to bump priority to be listed first from left to right)
--LINE 139 can be unremarked and used to further limit to specific CON.RL relation types of your choice
--Create CONP Custom View if not present - Run line 6 if you wish to drop a prior CONP rendition before I added version control
/* 
drop view CONP; delete from ctf where tc = 'CONP'; delete from ctd where tc = 'CONP';
*/
declare @version varchar(23) = '2019-02-13 20:00:00.000' --Specify a date in the distant future like 2199-01-01 to block revisions if you have customized this

set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'CONP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'CONP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale CONP view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''CONP''and o.[type_desc] = ''VIEW'') begin drop view CONP end; delete from ctf where tc = ''CONP''; delete from ctd where tc = ''CONP'';'
exec (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
create view CONP as
--CONP - Pivoted View of up to 6 most appropriate Emergency contacts - Custom View - Jared Kuszewski - Aeries Software - Version = ''' + @version + '''
SELECT PID ID, 
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN RL ELSE NULL END),'''') AS RL1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN CD ELSE NULL END),'''') AS CD1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN NM ELSE NULL END),'''') AS NM1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN FN ELSE NULL END),'''') AS FN1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN LN ELSE NULL END),'''') AS LN1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN TL ELSE NULL END),'''') AS TL1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN CP ELSE NULL END),'''') AS CP1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN WP ELSE NULL END),'''') AS WP1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN EM ELSE NULL END),'''') AS EM1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN AD ELSE NULL END),'''') AS AD1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN CY ELSE NULL END),'''') AS CY1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN ST ELSE NULL END),'''') AS ST1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN ZC ELSE NULL END),'''') AS ZC1,
ISNULL(MAX(CASE WHEN C.ROWNUM = 1 THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSE NULL END),'''') AS ME1,

ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN RL ELSE NULL END),'''') AS RL2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN CD ELSE NULL END),'''') AS CD2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN NM ELSE NULL END),'''') AS NM2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN FN ELSE NULL END),'''') AS FN2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN LN ELSE NULL END),'''') AS LN2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN TL ELSE NULL END),'''') AS TL2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN CP ELSE NULL END),'''') AS CP2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN WP ELSE NULL END),'''') AS WP2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN EM ELSE NULL END),'''') AS EM2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN AD ELSE NULL END),'''') AS AD2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN CY ELSE NULL END),'''') AS CY2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN ST ELSE NULL END),'''') AS ST2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN ZC ELSE NULL END),'''') AS ZC2,
ISNULL(MAX(CASE WHEN C.ROWNUM = 2 THEN REPLACE(REPLACE(REPLACE(REPLACE(ME,CHAR(13)+CHAR(10),'' ''),CHAR(13),'' ''),CHAR(10),'' ''),CHAR(9),'' '') ELSE NULL END),'''') AS ME2,

ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN RL ELSE NULL END),'''') AS RL3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN CD ELSE NULL END),'''') AS CD3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN NM ELSE NULL END),'''') AS NM3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN FN ELSE NULL END),'''') AS FN3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN LN ELSE NULL END),'''') AS LN3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN TL ELSE NULL END),'''') AS TL3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN CP ELSE NULL END),'''') AS CP3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN WP ELSE NULL END),'''') AS WP3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN EM ELSE NULL END),'''') AS EM3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN AD ELSE NULL END),'''') AS AD3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN CY ELSE NULL END),'''') AS CY3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN ST ELSE NULL END),'''') AS ST3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN ZC ELSE NULL END),'''') AS ZC3,
ISNULL(MAX(CASE WHEN C.ROWNUM = 3 THEN REPLACE(REPLACE(REPLACE(REPLACE(ME,CHAR(13)+CHAR(10),'' ''),CHAR(13),'' ''),CHAR(10),'' ''),CHAR(9),'' '') ELSE NULL END),'''') AS ME3,
'

select @DynaQuery += N'
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN RL ELSE NULL END),'''') AS RL4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN CD ELSE NULL END),'''') AS CD4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN NM ELSE NULL END),'''') AS NM4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN FN ELSE NULL END),'''') AS FN4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN LN ELSE NULL END),'''') AS LN4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN TL ELSE NULL END),'''') AS TL4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN CP ELSE NULL END),'''') AS CP4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN WP ELSE NULL END),'''') AS WP4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN EM ELSE NULL END),'''') AS EM4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN AD ELSE NULL END),'''') AS AD4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN CY ELSE NULL END),'''') AS CY4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN ST ELSE NULL END),'''') AS ST4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN ZC ELSE NULL END),'''') AS ZC4,
ISNULL(MAX(CASE WHEN C.ROWNUM = 4 THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSE NULL END),'''') AS ME4,

ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN RL ELSE NULL END),'''') AS RL5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN CD ELSE NULL END),'''') AS CD5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN NM ELSE NULL END),'''') AS NM5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN FN ELSE NULL END),'''') AS FN5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN LN ELSE NULL END),'''') AS LN5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN TL ELSE NULL END),'''') AS TL5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN CP ELSE NULL END),'''') AS CP5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN WP ELSE NULL END),'''') AS WP5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN EM ELSE NULL END),'''') AS EM5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN AD ELSE NULL END),'''') AS AD5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN CY ELSE NULL END),'''') AS CY5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN ST ELSE NULL END),'''') AS ST5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN ZC ELSE NULL END),'''') AS ZC5,
ISNULL(MAX(CASE WHEN C.ROWNUM = 5 THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSE NULL END),'''') AS ME5,

ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN RL ELSE NULL END),'''') AS RL6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN CD ELSE NULL END),'''') AS CD6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN NM ELSE NULL END),'''') AS NM6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN FN ELSE NULL END),'''') AS FN6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN LN ELSE NULL END),'''') AS LN6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN TL ELSE NULL END),'''') AS TL6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN CP ELSE NULL END),'''') AS CP6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN WP ELSE NULL END),'''') AS WP6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN EM ELSE NULL END),'''') AS EM6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN AD ELSE NULL END),'''') AS AD6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN CY ELSE NULL END),'''') AS CY6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN ST ELSE NULL END),'''') AS ST6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN ZC ELSE NULL END),'''') AS ZC6,
ISNULL(MAX(CASE WHEN C.ROWNUM = 6 THEN replace(replace(replace(replace(me,char(13)+char(10),'' ''),char(13),'' ''),char(10),'' ''),char(9),'' '') ELSE NULL END),'''') AS ME6,

0 DEL,
CURRENT_TIMESTAMP DTS
FROM 
(SELECT 
ROW_NUMBER() OVER (PARTITION BY PID ORDER BY 
[OR] 
- CASE WHEN PC = ''Y'' THEN 1 ELSE 0 END
- CASE WHEN AP = ''Y'' THEN 1 ELSE 0 END
- CASE WHEN LW = ''Y'' THEN 1 ELSE 0 END
- CASE WHEN ERH = ''Y'' THEN 1 ELSE 0 END) 
-- CASE WHEN  c1d <> '''' or c2d <> '''' THEN 1 ELSE 0 END --Take away the dash so this line begins like the one above if contact linking also makes them a more prominent contact?
ROWNUM,
PID, RL, CD, NM, FN, LN, TL, CP, WP, EM, AD, CY, ST, ZC, ME
FROM CON 

WHERE DEL = 0 AND RF <> 1 
--AND RL IN (''10'',''11'') --LIMIT TO SPECIFIC RELATIONSHIP CODES WITH THIS LINE IF DESIRED 
AND CD NOT IN (SELECT CD FROM COD WHERE TC = ''CON'' AND FC = ''CD'' AND DEL = 0 AND N1 = 9)
AND PID IN (SELECT DISTINCT ID FROM STU WHERE DEL = 0)
) C
GROUP BY PID
'



--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)


insert CTD (TC, NM, NLC, PKF, PT, PF, CF, OM, OB, VW)
select 'CONP','Contacts On One Line (Pivoted)','','ID','STU','ID','ID','One','ID','1'

insert ctf (TC, FC, SQ, NM, TY, DL)
values 
('CONP','RL1','1','Contact 1 Relation Code','Text','600'),
('CONP','CD1','3','Contact 1 Code','Text','600'),
('CONP','NM1','5','Contact 1 Full Name','Text','600'),
('CONP','FN1','7','Contact 1 First Name','Text','600'),
('CONP','LN1','9','Contact 1 Last Name','Text','600'),
('CONP','TL1','11','Contact 1 Telephone','Text','600'),
('CONP','CP1','13','Contact 1 Cell Phone','Text','600'),
('CONP','WP1','15','Contact 1 Work Phone','Text','600'),
('CONP','EM1','17','Contact 1 email','Text','600'),
('CONP','AD1','19','Contact 1 Address','Text','600'),
('CONP','CY1','21','Contact 1 City','Text','600'),
('CONP','ST1','23','Contact 1 State','Text','600'),
('CONP','ZC1','25','Contact 1 ZIP code','Text','600'),
('CONP','ME1','27','Contact 1 Memo','Text','600'),
('CONP','RL2','29','Contact 2 Relation Code','Text','600'),
('CONP','CD2','31','Contact 2 Code','Text','600'),
('CONP','NM2','33','Contact 2 Full Name','Text','600'),
('CONP','FN2','35','Contact 2 First Name','Text','600'),
('CONP','LN2','37','Contact 2 Last Name','Text','600'),
('CONP','TL2','39','Contact 2 Telephone','Text','600'),
('CONP','CP2','41','Contact 2 Cell Phone','Text','600'),
('CONP','WP2','43','Contact 2 Work Phone','Text','600'),
('CONP','EM2','45','Contact 2 email','Text','600'),
('CONP','AD2','47','Contact 2 Address','Text','600'),
('CONP','CY2','49','Contact 2 City','Text','600'),
('CONP','ST2','51','Contact 2 State','Text','600'),
('CONP','ZC2','53','Contact 2 ZIP code','Text','600'),
('CONP','ME2','55','Contact 2 Memo','Text','600'),
('CONP','RL3','57','Contact 3 Relation Code','Text','600'),
('CONP','CD3','59','Contact 3 Code','Text','600'),
('CONP','NM3','61','Contact 3 Full Name','Text','600'),
('CONP','FN3','63','Contact 3 First Name','Text','600'),
('CONP','LN3','65','Contact 3 Last Name','Text','600'),
('CONP','TL3','67','Contact 3 Telephone','Text','600'),
('CONP','CP3','69','Contact 3 Cell Phone','Text','600'),
('CONP','WP3','71','Contact 3 Work Phone','Text','600'),
('CONP','EM3','73','Contact 3 email','Text','600'),
('CONP','AD3','75','Contact 3 Address','Text','600'),
('CONP','CY3','77','Contact 3 City','Text','600'),
('CONP','ST3','79','Contact 3 State','Text','600'),
('CONP','ZC3','81','Contact 3 ZIP code','Text','600'),
('CONP','ME3','83','Contact 3 Memo','Text','600'),
('CONP','RL4','85','Contact 4 Relation Code','Text','600'),
('CONP','CD4','87','Contact 4 Code','Text','600'),
('CONP','NM4','89','Contact 4 Full Name','Text','600'),
('CONP','FN4','91','Contact 4 First Name','Text','600'),
('CONP','LN4','93','Contact 4 Last Name','Text','600'),
('CONP','TL4','95','Contact 4 Telephone','Text','600'),
('CONP','CP4','97','Contact 4 Cell Phone','Text','600'),
('CONP','WP4','99','Contact 4 Work Phone','Text','600'),
('CONP','EM4','101','Contact 4 email','Text','600'),
('CONP','AD4','103','Contact 4 Address','Text','600'),
('CONP','CY4','105','Contact 4 City','Text','600'),
('CONP','ST4','107','Contact 4 State','Text','600'),
('CONP','ZC4','109','Contact 4 ZIP code','Text','600'),
('CONP','ME4','111','Contact 4 Memo','Text','600'),
('CONP','RL5','113','Contact 5 Relation Code','Text','600'),
('CONP','CD5','115','Contact 5 Code','Text','600'),
('CONP','NM5','117','Contact 5 Full Name','Text','600'),
('CONP','FN5','119','Contact 5 First Name','Text','600'),
('CONP','LN5','121','Contact 5 Last Name','Text','600'),
('CONP','TL5','123','Contact 5 Telephone','Text','600'),
('CONP','CP5','125','Contact 5 Cell Phone','Text','600'),
('CONP','WP5','127','Contact 5 Work Phone','Text','600'),
('CONP','EM5','129','Contact 5 email','Text','600'),
('CONP','AD5','131','Contact 5 Address','Text','600'),
('CONP','CY5','133','Contact 5 City','Text','600'),
('CONP','ST5','135','Contact 5 State','Text','600'),
('CONP','ZC5','137','Contact 5 ZIP code','Text','600'),
('CONP','ME5','139','Contact 5 Memo','Text','600'),
('CONP','RL6','141','Contact 6 Relation Code','Text','600'),
('CONP','CD6','143','Contact 5 Code','Text','600'),
('CONP','NM6','145','Contact 6 Full Name','Text','600'),
('CONP','FN6','147','Contact 6 First Name','Text','600'),
('CONP','LN6','149','Contact 6 Last Name','Text','600'),
('CONP','TL6','151','Contact 6 Telephone','Text','600'),
('CONP','CP6','153','Contact 6 Cell Phone','Text','600'),
('CONP','WP6','155','Contact 6 Work Phone','Text','600'),
('CONP','EM6','157','Contact 6 email','Text','600'),
('CONP','AD6','159','Contact 6 Address','Text','600'),
('CONP','CY6','161','Contact 6 City','Text','600'),
('CONP','ST6','163','Contact 6 State','Text','600'),
('CONP','ZC6','165','Contact 6 ZIP code','Text','600'),
('CONP','ME6','167','Contact 6 Memo','Text','600')

insert CTF (TC, FC, SQ)
select top (select count(*) - 1 from ctf where tc = 'CONP') 
'CONP' TC, FC = 'NEWLINE' + cast(row_number() over (order by sq) as varchar(4)),
sq + 1 SQ
from ctf where tc = 'CONP'

print 'CONP Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of CONP blocked by version control - CONP needs no update or was customized.'
set nocount off
GO

--GBKA - Gradebook Use Analysis - Custom View - Aeries Software - Jared Kuszewski
--Create GBKA Custom View if not present - Run line 4 if you wish to drop a prior GBKA rendition before I added version control
/* 
drop view GBKA; delete from ctf where tc = 'GBKA'; delete from ctd where tc = 'GBKA';
*/
declare @version varchar(23) = '2019-02-07 08:13:00.000'
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'GBKA'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > --your version here
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'GBKA'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale GBKA view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''GBKA''and o.[type_desc] = ''VIEW'') begin drop view GBKA end; delete from ctf where tc = ''GBKA''; delete from ctd where tc = ''GBKA'';'
exec (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
--GBKA - Gradebook Use Analysis - Custom View - Jared Kuszewski - Aeries Software - Version = ''' + @version + '''
create view GBKA as
--Gradebook Analysis (GBKA) - 10/04/2018 Jared Kuszewski Aeries Software
--Sorted by department and median percent descending
--Note: Initial gradebook name and period may not match later decisions to associate to a section for a different period or Course.
--Purpose: This gives administration one perspective of how their team of teachers is performing in grading. This can be a conversation starter. Use caution presuming it to tell you the whole story. An Easy "A" may not be good and harsh grades can be bad too. Since competitive options of school choices are available, it is good to know that your team is on point. You can assist those that may need help.
select SchoolNum SC,
ISNULL((SELECT TOP 1 SN FROM STU WHERE SC = SCHOOLNUM AND DEL = 0 AND TG = '''' ORDER BY LN, FN),0) SN,
1 SQ, 
SchoolName NM, 
TeacherName TE, 
GBK_Num GNB, 
GBK_Name GNM, 
CourseTitle CO, 
Dept DC, 
GradReq S1, 
GB_Term TM, 
pd PD, 
MinPercent MNP, 
AvgPercent AVP, 
MedianPercent MDP, 
MaxPercent MXP, 
AssignmentCount ACN, 
StuCount UDS, 
MinDueDate MDT, 
MedianDueDate MDD, 
MaxDueDate MXD,
LastUpdated LUP,
0 DEL,
CURRENT_TIMESTAMP DTS

from (

select gbk.sc SchoolNum, loc.nm SchoolName, tch.te TeacherName, gbk.gn GBK_Num, gbk.nm GBK_Name, crs.co CourseTitle, crs.dc Dept, crs.s1 GradReq, gbr.cd GB_Term, gbk.pd, 
min(gbv.pc) MinPercent, 
avg(gbv.pc) AvgPercent
,((select max(pc) from (select top 50 percent pc from gbv v where gn = gbk.gn and cd = gbr.cd 
and pc <> 0 --omit zero percent (This takes willful disobedience)
order by pc) A) + 
(select min(pc) from (select top 50 percent pc from gbv v where gn = gbk.gn and cd = gbr.cd 
and pc <> 0 --omit zero percent (This takes willful disobedience)
order by pc desc) B)) / 2 MedianPercent
, max(gbv.pc) MaxPercent
,(select count(*) from gba where gn = gbk.gn and dd between gbr.sd and gbr.ed) AssignmentCount
, (select count(*) from gbu where sc = gbk.sc and gn = gbk.gn and gbu.d1 <= gbr.ed and (gbu.d2 is null or gbu.d2 >= gbr.sd

and tg <> ''I'' --and not dropped with this line

 )) STUcount
,convert(varchar(10),(select min(dd) from gba where gn = gbk.gn and dd between gbr.sd and gbr.ed),101) as MinDueDate 
,convert(varchar(10),cast(((select max(cast(dd as bigint)) from (select top 50 percent dd from GBA d where gn = gbk.gn and dd between gbr.sd and gbr.ed order by dd) A) + 
(select min(cast(dd as bigint)) from (select top 50 percent dd from GBA d where gn = gbk.gn and dd between gbr.sd and gbr.ed order by dd desc) B)) / 2 as datetime),101)  MedianDueDate
,convert(varchar(10),(select max(dd) from gba where gn = gbk.gn and dd between gbr.sd and gbr.ed),101) as MaxDueDate
,(select max(dts) from gbv v where gn = gbk.gn) LastUpdated
from gbk inner join gbu on gbk.gn = gbu.gn and gbk.sc = gbu.sc
inner join loc on gbk.sc = loc.cd
inner join tch on gbk.sc = tch.sc and gbk.tn = tch.tn
inner join gbv on gbu.sc = gbv.sc and gbu.sn = gbv.sn and gbu.gn = gbv.gn
inner join gbr on gbk.gn = gbr.gn and gbv.cd = gbr.cd
left join gbe on gbk.gn = gbe.gn
left join mst on gbe.sc = mst.sc and gbe.se = mst.se
left join crs on mst.cn = crs.cn
where gbu.d1 <= gbr.ed and (gbu.d2 is null or gbu.d2 >= gbr.sd)

and gbu.tg <> ''I'' --and not dropped with this line

and gbv.pc <> 0 --omit zero percent (This takes willful disobedience)

group by 
gbk.sc, gbk.gn, loc.nm, tch.te, gbk.nm, crs.co, crs.dc, crs.s1, gbr.cd, gbk.pd, gbr.sd, gbr.ed
) gb
where STUcount > 1 --omitting gradebooks with just one kid (likely Teacher''s Aides)
'

exec (@DynaQuery)

INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'GBKA', N'Gradebook Analysis', N'', N'SC,SN,SQ', N'STU', N'SC,SN', N'SC,SN', N'Many', N'SC,DC,MDP DESC', 0, CAST(N'2018-10-04T23:56:31.573' AS DateTime), 1)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'NM', 1, N'SchoolName', N'Text', 300, 0, 0, 0, CAST(N'2018-10-04T23:57:32.687' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'TE', 2, N'TeacherName', N'Text', 300, 0, 0, 0, CAST(N'2018-10-04T23:58:03.573' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'GNB', 3, N'GBNumber', N'Text', 100, 0, 0, 0, CAST(N'2018-10-04T23:59:14.470' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'GNM', 4, N'GradebookName', N'Text', 300, 0, 0, 0, CAST(N'2018-10-04T23:59:43.653' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'CO', 5, N'CourseTitle', N'Text', 300, 0, 0, 0, CAST(N'2018-10-05T00:00:32.937' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'DC', 6, N'Dept', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:02:35.873' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'S1', 7, N'GradReq', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:02:29.567' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'TM', 8, N'Term', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:02:54.617' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'PD', 9, N'Period', N'Text', 15, 0, 0, 0, CAST(N'2018-10-05T00:03:20.870' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MNP', 10, N'MinPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:03:58.647' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'AVP', 11, N'AvgPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:04:27.357' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MDP', 12, N'MedianPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:05:48.000' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MXP', 13, N'MaxPercent', N'Text', 70, 0, 0, 0, CAST(N'2018-10-05T00:06:10.383' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'ACN', 14, N'AssignmentCount', N'Text', 40, 0, 0, 0, CAST(N'2018-10-05T00:06:42.340' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'UDS', 15, N'UndroppedSTUcount', N'Text', 40, 0, 0, 0, CAST(N'2018-10-05T00:07:35.507' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MDT', 16, N'MinDueDate', N'Date', 100, 0, 0, 0, CAST(N'2018-10-05T00:08:10.500' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MDD', 17, N'MedianDueDate', N'Date', 100, 0, 0, 0, CAST(N'2018-10-05T00:08:31.320' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'MXD', 18, N'MaxDueDate', N'Date', 100, 0, 0, 0, CAST(N'2018-10-05T00:08:59.377' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GBKA', N'LUP', 19, N'LastUpdated', N'Text', 300, 0, 0, 0, CAST(N'2018-10-05T00:09:42.560' AS DateTime))

print 'GBKA Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of GBKA blocked by version control - GBKA needs no update or was customized.'
set nocount off
GO

--GradebookClassStats - Custom View - Aeries Software - Jared Kuszewski
--Create GradebookClassStats Custom View if not present - Run line 4 if you wish to drop a prior GradebookClassStats rendition
/* 
drop view GradebookClassStats; delete from ctf where tc = 'GradebookClassStats'; delete from ctd where tc = 'GradebookClassStats';
*/
declare @version varchar(23) = '2019-03-01 20:00:00.000'
set nocount on
if exists (select top 1 1 from sys.objects o inner join sys.sql_modules m on o.object_id = m.object_id where o.[name] = 'GBKA')
BEGIN
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'GradebookClassStats'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > --your version here
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'GradebookClassStats'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale GradebookClassStats view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''GradebookClassStats''and o.[type_desc] = ''VIEW'') begin drop view GradebookClassStats end; delete from ctf where tc = ''GradebookClassStats''; delete from ctd where tc = ''GradebookClassStats'';'
exec (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
Create VIEW GradebookClassStats
as
SELECT        STU.SC, STU.SN, 
ROW_NUMBER() OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, GBKA.PD, GBKA.TM, GBKA.NM) SQ
,GBV.MK YMK, GBV.PC YPC
, GBKA.NM, GBKA.TE, GBKA.GNB, GBKA.GNM, GBKA.CO, GBKA.DC, GBKA.S1, GBKA.TM, GBKA.PD, GBKA.MNP, GBKA.AVP, GBKA.MDP, GBKA.MXP, GBKA.ACN, GBKA.UDS, GBKA.MDT, GBKA.MDD, GBKA.MXD, GBKA.LUP, GBKA.DEL, GBKA.DTS
FROM            
GBKA INNER JOIN GBU ON GBU.GN = GBKA.GNB
INNER JOIN STU ON STU.SC = GBU.SC AND STU.SN = GBU.SN AND STU.DEL = 0
INNER JOIN GBV ON STU.SC = GBV.SC AND STU.SN = GBV.SN AND GBV.GN = GBKA.GNB AND GBV.CD = GBKA.TM
'

exec (@DynaQuery)

INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'GradebookClassStats', N'Gradebook Class Statistics', N'Student Data|Grades', N'SC,SN,SQ', N'STU', N'SC,SN', N'SC,SN', N'Many', N'SQ', 0, CAST(N'2019-02-05T08:32:42.840' AS DateTime), 1)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'DC', 0, N'Dept', N'Text', 15, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'GNB', 0, N'GBNumber', N'Text', 100, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'S1', 0, N'GradReq', N'Text', 15, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NM', 0, N'SchoolName', N'Text', 300, 0, 0, 1, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'TE', 1, N'Teacher Name', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T19:18:23.143' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'GNM', 2, N'Gradebook Name', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T19:18:20.060' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'CO', 3, N'Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T20:00:28.553' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'TM', 4, N'Term', N'Text', 15, 0, 0, 0, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'PD', 5, N'Period', N'Text', 15, 0, 0, 0, CAST(N'2019-02-05T08:32:42.840' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE4', 6, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:15:38.347' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'YMK', 7, N'Your Mark', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:17:06.373' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'YPC', 8, N'Your Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:17:06.377' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE1', 9, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:17:06.383' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MNP', 10, N'Class Minimum Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:18:40.920' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'AVP', 11, N'Class Average Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:18:56.360' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MDP', 12, N'Class Median Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:19:04.677' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MXP', 13, N'Class Max Percent', N'Text', 70, 0, 0, 0, CAST(N'2019-03-01T19:19:16.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE2', 14, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:17:06.403' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'ACN', 15, N'Total Assignments This Term', N'Text', 40, 0, 0, 0, CAST(N'2019-03-01T19:19:57.127' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'UDS', 16, N'Students in this Gradebook', N'Text', 40, 0, 0, 0, CAST(N'2019-03-01T19:20:14.393' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE3', 17, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:17:06.410' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MDT', 18, N'Earliest Assigment Due Date', N'Date', 100, 0, 0, 0, CAST(N'2019-03-01T19:20:50.703' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MDD', 19, N'Median Assignment Due Date', N'Date', 100, 0, 0, 0, CAST(N'2019-03-01T19:58:52.090' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'MXD', 20, N'Latest Assignment Due Date (at this time)', N'Date', 100, 0, 0, 0, CAST(N'2019-03-01T19:59:06.057' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'NEWLINE5', 21, N'', N'', 0, 0, 0, 0, CAST(N'2019-03-01T19:59:51.070' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'GradebookClassStats', N'LUP', 22, N'Last Updated (for this class)', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T19:59:51.073' AS DateTime))


print 'GradebookClassStats Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of GradebookClassStats blocked by version control - GradebookClassStats needs no update or was customized.'
set nocount off
END
else Print 'This depends on the existence of GBKA. Please create that view first.'
GO

--MSTP - Classes pivoted for the current or custom day in APDS.JOD - Custom View - Aeries Software - Jared Kuszewski
--So if students attend different classes each day or you use A/B day scheduling. Just use this on a similar dayof the week.
--Create MSTP Custom View if not present - Run line 5 if you wish to drop a prior MSTP rendition before I added version control
/* 
drop view MSTP; delete from ctf where tc = 'MSTP'; delete from ctd where tc = 'MSTP';drop table APDS; delete from ctf where tc = 'APDS'; delete from ctd where tc = 'APDS';
*/
declare @version varchar(23) = '2022-09-26 16:45:00.000' --Specify a date in the distant future like 2199-01-01 to block revisions if you have customized this

set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'MSTP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'MSTP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale MSTP view if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''MSTP''and o.[type_desc] = ''VIEW'') begin drop view MSTP end; delete from ctf where tc = ''MSTP''; delete from ctd where tc = ''MSTP'';'
exec (@DynaQuery)
set @DynaQuery = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@DynaQuery)
set @DynaQuery = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@DynaQuery)
set @DynaQuery = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@DynaQuery)

set @DynaQuery = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
'
EXEC (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
--MSTP - Classes pivoted for the current Day - Custom View - Jared Kuszewski - Aeries Software - Version = ''' + @version + '''
Create View [dbo].[MSTP] as

WITH TDAYS (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
''A''+T1 as T1, 
''B''+T2 as T2, 
''C''+T3 as T3, 
''D''+T4 as T4, 
''E''+T5 as T5, 
''F''+T6 as T6, 
''G''+T7 as T7, 
''H''+T8 as T8, 
''I''+T9 as T9, 
''J''+T10 as T10, 
''K''+T11 as T11, 
''L''+T12 as T12, 
''M''+T13 as T13, 
''N''+T14 as T14, 
''O''+T15 as T15, 
''P''+T16 as T16, 
''Q''+T17 as T17, 
''R''+T18 as T18, 
''S''+T19 as T19, 
''T''+T20 as T20, 
''U''+T21 as T21, 
''V''+T22 as T22, 
''W''+T23 as T23, 
''X''+T24 as T24, 
''Y''+T25 as T25, 
''Z''+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv
where ascii(left(TrackHO,1)) between 64 and (64 + (select k from loc where del = 0 and cd = unpiv.sc))
union 
select SC, DY, DT, AB, HO, BL, '' '' + HO AS TrackHO from day where DEL = 0
) trackdays
)

--The MST Class Pivot

SELECT SC, SN
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN SM END),'''') SM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(PD AS VARCHAR(6)) END),'''') PD1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(se AS VARCHAR(5)) END),'''') SE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(TE AS VARCHAR(500)) END),'''') TE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN RM END),'''') RM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CN END),'''') CN1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CO END),'''') CO1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN DE END),'''') DE1

,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN SM END),'''') SM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(PD AS VARCHAR(6)) END),'''') PD2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(se AS VARCHAR(5)) END),'''') SE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(TE AS VARCHAR(500)) END),'''') TE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN RM END),'''') RM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CN END),'''') CN2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CO END),'''') CO2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN DE END),'''') DE2

,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN SM END),'''') SM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(PD AS VARCHAR(6)) END),'''') PD3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(se AS VARCHAR(5)) END),'''') SE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(TE AS VARCHAR(500)) END),'''') TE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN RM END),'''') RM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CN END),'''') CN3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CO END),'''') CO3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN DE END),'''') DE3

,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN SM END),'''') SM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(PD AS VARCHAR(6)) END),'''') PD4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(se AS VARCHAR(5)) END),'''') SE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(TE AS VARCHAR(500)) END),'''') TE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN RM END),'''') RM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CN END),'''') CN4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CO END),'''') CO4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN DE END),'''') DE4

,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN SM END),'''') SM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(PD AS VARCHAR(6)) END),'''') PD5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(se AS VARCHAR(5)) END),'''') SE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(TE AS VARCHAR(500)) END),'''') TE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN RM END),'''') RM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CN END),'''') CN5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CO END),'''') CO5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN DE END),'''') DE5

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN SM END),'''') SM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(PD AS VARCHAR(6)) END),'''') PD6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(se AS VARCHAR(5)) END),'''') SE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(TE AS VARCHAR(500)) END),'''') TE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN RM END),'''') RM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CN END),'''') CN6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CO END),'''') CO6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN DE END),'''') DE6

,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN SM END),'''') SM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(PD AS VARCHAR(6)) END),'''') PD7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(se AS VARCHAR(5)) END),'''') SE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(TE AS VARCHAR(500)) END),'''') TE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN RM END),'''') RM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CN END),'''') CN7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CO END),'''') CO7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN DE END),'''') DE7

,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN SM END),'''') SM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(PD AS VARCHAR(6)) END),'''') PD8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(se AS VARCHAR(5)) END),'''') SE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(TE AS VARCHAR(500)) END),'''') TE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN RM END),'''') RM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CN END),'''') CN8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CO END),'''') CO8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN DE END),'''') DE8

,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN SM END),'''') SM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(PD AS VARCHAR(6)) END),'''') PD9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(se AS VARCHAR(5)) END),'''') SE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(TE AS VARCHAR(500)) END),'''') TE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN RM END),'''') RM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CN END),'''') CN9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CO END),'''') CO9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN DE END),'''') DE9

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN SM END),'''') SM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(PD AS VARCHAR(6)) END),'''') PD10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(se AS VARCHAR(5)) END),'''') SE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(TE AS VARCHAR(500)) END),'''') TE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN RM END),'''') RM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CN END),'''') CN10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CO END),'''') CO10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN DE END),'''') DE10
,0 DEL
,GETDATE() DTS

FROM (
SELECT STU.SC, STU.SN, MST.SM, MST.PD, MST.SE, TCH.TE, MST.RM, CRS.CN, CRS.CO, CRS.DE,
ROW_NUMBER () OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, MST.PD, MST.SE) ClassOrder
FROM
STU 
LEFT JOIN SEC ON STU.SC = SEC.SC AND STU.SN = SEC.SN AND SEC.DEL = 0
LEFT JOIN MST ON SEC.SC = MST.SC  AND SEC.SE = MST.SE AND MST.DEL = 0
LEFT JOIN CRS ON MST.CN = CRS.CN AND CRS.DEL = 0
LEFT JOIN TCH ON MST.SC = TCH.SC AND MST.TN = TCH.TN AND TCH.DEL = 0
WHERE STU.DEL = 0
AND STU.SC NOT IN (SELECT CD FROM LOC WHERE DEL = 0 AND E = ''3'')
AND (MST.SM IS NULL OR MST.SM 
IN (SELECT TM FROM TRM 
WHERE CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END BETWEEN D1 AND D2)) --ONLY CURRENT TERMS
AND STU.SC IN (SELECT CD FROM LOC WHERE E in (0,2) AND DEL = 0 AND TG = '''') --Just master schedule schools
AND 1 = CASE 
WHEN MST.DY = ''A-DAYS'' AND 
CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END
= (SELECT DT FROM TDAYS WHERE SC = STU.SC AND Track = STU.TR AND AB = ''A'' AND BL LIKE (''%'' + CAST(MST.PD AS VARCHAR(1)) + ''%'') AND DT 
= CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END) THEN 1
WHEN MST.DY = ''B-DAYS'' AND 
CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END
= (SELECT DT FROM TDAYS WHERE SC = STU.SC AND Track = STU.TR AND AB = ''B'' AND BL LIKE (''%'' + CAST(MST.PD AS VARCHAR(1)) + ''%'') AND DT 
= CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END) THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 2 AND MST.MM = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 3 AND MST.MT = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 4 AND MST.MW = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 5 AND MST.MR = 1 THEN 1
WHEN MST.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 6 AND MST.MF = 1 THEN 1
ELSE 0
END
) Classes

GROUP BY SC, SN


union all

'
select @DynaQuery += N'
--The MST Class Pivot FLEX
SELECT SC, SN
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN SM END),'''') SM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(PD AS VARCHAR(6)) END),'''') PD1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(se AS VARCHAR(5)) END),'''') SE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(TE AS VARCHAR(500)) END),'''') TE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN RM END),'''') RM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CN END),'''') CN1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CO END),'''') CO1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN DE END),'''') DE1

,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN SM END),'''') SM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(PD AS VARCHAR(6)) END),'''') PD2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(se AS VARCHAR(5)) END),'''') SE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(TE AS VARCHAR(500)) END),'''') TE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN RM END),'''') RM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CN END),'''') CN2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CO END),'''') CO2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN DE END),'''') DE2

,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN SM END),'''') SM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(PD AS VARCHAR(6)) END),'''') PD3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(se AS VARCHAR(5)) END),'''') SE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(TE AS VARCHAR(500)) END),'''') TE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN RM END),'''') RM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CN END),'''') CN3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CO END),'''') CO3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN DE END),'''') DE3

,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN SM END),'''') SM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(PD AS VARCHAR(6)) END),'''') PD4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(se AS VARCHAR(5)) END),'''') SE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(TE AS VARCHAR(500)) END),'''') TE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN RM END),'''') RM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CN END),'''') CN4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CO END),'''') CO4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN DE END),'''') DE4

,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN SM END),'''') SM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(PD AS VARCHAR(6)) END),'''') PD5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(se AS VARCHAR(5)) END),'''') SE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(TE AS VARCHAR(500)) END),'''') TE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN RM END),'''') RM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CN END),'''') CN5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CO END),'''') CO5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN DE END),'''') DE5

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN SM END),'''') SM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(PD AS VARCHAR(6)) END),'''') PD6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(se AS VARCHAR(5)) END),'''') SE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(TE AS VARCHAR(500)) END),'''') TE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN RM END),'''') RM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CN END),'''') CN6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CO END),'''') CO6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN DE END),'''') DE6

,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN SM END),'''') SM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(PD AS VARCHAR(6)) END),'''') PD7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(se AS VARCHAR(5)) END),'''') SE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(TE AS VARCHAR(500)) END),'''') TE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN RM END),'''') RM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CN END),'''') CN7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CO END),'''') CO7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN DE END),'''') DE7

,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN SM END),'''') SM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(PD AS VARCHAR(6)) END),'''') PD8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(se AS VARCHAR(5)) END),'''') SE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(TE AS VARCHAR(500)) END),'''') TE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN RM END),'''') RM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CN END),'''') CN8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CO END),'''') CO8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN DE END),'''') DE8

,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN SM END),'''') SM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(PD AS VARCHAR(6)) END),'''') PD9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(se AS VARCHAR(5)) END),'''') SE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(TE AS VARCHAR(500)) END),'''') TE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN RM END),'''') RM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CN END),'''') CN9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CO END),'''') CO9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN DE END),'''') DE9

,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN SM END),'''') SM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(PD AS VARCHAR(6)) END),'''') PD10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(se AS VARCHAR(5)) END),'''') SE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(TE AS VARCHAR(500)) END),'''') TE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN RM END),'''') RM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CN END),'''') CN10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CO END),'''') CO10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN DE END),'''') DE10
,0 DEL
,GETDATE() DTS

'
select @DynaQuery += N'

FROM (
SELECT 
STU.SC, STU.SN, MST.SM, FTF.STI PD, MST.SE, 
STUFF(
(SELECT  '' | '',STF.FN + '' '' + STF.LN
FROM SSE 
INNER JOIN STF ON SSE.ID = STF.ID
WHERE SSE.DEL = 0 AND STF.DEL = 0 AND SSE.TG = '''' 
AND COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy'')) BETWEEN
COALESCE(SD,''1/1/1900'')
AND
COALESCE(ED,''12/31/9999'')
AND SSE.SC = MST.SC AND SSE.SE = MST.SE
ORDER BY PR DESC, SD
FOR XML PATH (''''))
, 1, 3, '''') TE
, MST.RM, CRS.CN, CRS.CO, CRS.DE,
ROW_NUMBER () OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, CAST(FORMAT(FTF.ST,''HH:mm:ss'') AS DATETIME), MST.SE) ClassOrder
FROM
(SELECT SC, SN, ID, TR FROM STU WHERE DEL = 0) STU
INNER JOIN (SELECT * FROM CAR WHERE DEL = 0) CAR ON STU.SC = CAR.SC AND STU.SN = CAR.SN
LEFT JOIN (SELECT * FROM CRS WHERE DEL = 0) CRS ON CAR.CN = CRS.CN
INNER JOIN (SELECT * FROM TDAYS WHERE DT < GETDATE() AND HO NOT IN (''@'',''#'',''$'',''*'')) TDAYS ON TDAYS.SC = STU.SC AND TDAYS.Track = STU.TR
LEFT JOIN (SELECT * FROM MST WHERE DEL = 0) MST ON MST.SC = CAR.SC AND MST.SE = CAR.SE
INNER JOIN (SELECT * FROM CCD WHERE DEL = 0) CCD ON MST.CSQ = CCD.CSQ AND CCD.DT = TDAYS.DT
INNER JOIN (SELECT * FROM FTF WHERE DEL = 0) FTF ON MST.FSQ = FTF.SQ
LEFT JOIN (SELECT * FROM APDS WHERE DEL = 0) APDS ON APDS.SC = STU.SC AND APDS.SN = STU.SN 
WHERE STU.SC IN (SELECT CD FROM LOC WHERE DEL = 0 AND E = ''3'')
AND COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy'')) BETWEEN CAR.DS AND CAR.DE --ONLY CURRENT TERMS
AND CCD.DT = COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy''))
) Classes

GROUP BY SC, SN

'

--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)


INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'MSTP', N'MST Classes Pivoted', N'', N'SC,SN', N'STU', N'SC,SN', N'SC,SN', N'One', N'SC,SN,SM,PD,SE', 0, CAST(N'2019-03-01T22:18:43.317' AS DateTime), 1)

INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM1', 1, N'Class 1 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:40.707' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD1', 2, N'Class 1 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:51.777' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE1', 3, N'Class 1 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:59.387' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE1', 4, N'Class 1 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:06.940' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM1', 5, N'Class 1 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:12.173' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN1', 6, N'Class 1 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:08.750' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO1', 7, N'Class 1 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:24.983' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE1', 8, N'Class 1 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:49.463' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM2', 9, N'Class 2 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:16.713' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD2', 10, N'Class 2 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:19.830' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE2', 11, N'Class 2 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:32.807' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE2', 12, N'Class 2 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:37.713' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM2', 13, N'Class 2 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:52.757' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN2', 14, N'Class 2 Couse ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:03.830' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO2', 15, N'Class 2 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:19.397' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE2', 16, N'Class 2 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:40.903' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM3', 17, N'Class 3 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:27:18.273' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD3', 18, N'Class 3 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:47.107' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE3', 19, N'Class 3 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:48.517' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE3', 20, N'Class 3 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:48.933' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM3', 21, N'Class 3 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:53.630' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN3', 22, N'Class 3 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:25.550' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO3', 23, N'Class 3 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:15.153' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE3', 24, N'Class 3 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:53.013' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM4', 25, N'Class 4 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:01.997' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD4', 26, N'Class 4 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:57.170' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE4', 27, N'Class 4 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:53.873' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE4', 28, N'Class 4 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:57.817' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM4', 29, N'Class 4 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:01.507' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN4', 30, N'Class 4 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:32.173' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO4', 31, N'Class 4 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:21.283' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE4', 32, N'Class 4 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:05.837' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM5', 33, N'Class 5 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:43.047' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD5', 34, N'Class 5 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:45.950' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE5', 35, N'Class 5 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:02.743' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE5', 36, N'Class 5 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:04.707' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM5', 37, N'Class 5 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:06.320' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN5', 38, N'Class 5 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:38.940' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO5', 39, N'Class 5 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:27.043' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE5', 40, N'Class 5 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:11.390' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM6', 41, N'Class 6 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:32.273' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD6', 42, N'Class 6 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:36.037' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE6', 43, N'Class 6 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:07.673' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE6', 44, N'Class 6 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:10.240' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM6', 45, N'Class 6 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:15.553' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN6', 46, N'Class 6 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:45.043' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO6', 47, N'Class 6 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:34.550' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE6', 48, N'Class 6 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:21.053' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM7', 49, N'Class 7 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:27:47.813' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD7', 50, N'Class 7 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:11.100' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE7', 51, N'Class 7 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:13.237' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE7', 52, N'Class 7 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:15.607' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM7', 53, N'Class 7 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:22.763' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN7', 54, N'Class 7 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:52.933' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO7', 55, N'Class 7 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:40.650' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE7', 56, N'Class 7 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:30.680' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM8', 57, N'Class 8 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:15.660' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD8', 58, N'Class 8 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:17.790' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE8', 59, N'Class 8 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:20.510' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE8', 60, N'Class 8 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:21.360' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM8', 61, N'Class 8 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:28.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN8', 62, N'Class 8 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:58.493' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO8', 63, N'Class 8 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:50.050' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE8', 64, N'Class 8 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:37.967' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM9', 65, N'Class 9 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:10.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD9', 66, N'Class 9 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:25.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE9', 67, N'Class 9 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:26.683' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE9', 68, N'Class 9 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:26.680' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM9', 69, N'Class 9 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:59.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN9', 70, N'Class 9 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:35:03.623' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO9', 71, N'Class 9 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:37:00.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE9', 72, N'Class 9 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:45.353' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SM10', 73, N'Class 10 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:34.657' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'PD10', 74, N'Class 10 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:32.300' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'SE10', 75, N'Class 10 Section', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:32.407' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'TE10', 76, N'Class 10 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:31.787' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'RM10', 77, N'Class 10 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:06.160' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CN10', 78, N'Class 10 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:35:08.913' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'CO10', 79, N'Class 10 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:37:07.783' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'MSTP', N'DE10', 80, N'Class 10 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:52.823' AS DateTime))

update apds set jod = getdate()
update apds set jod = getdate()

print 'MSTP Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of MSTP blocked by version control - MSTP needs no update or was customized.'
set nocount off
GO

--PGMS - Program and Authorization Status - Custom View - Aeries Software - Jared Kuszewski
--If you comission a new PGM or AUT code, you will want to drop and recreate to include it - Run line 4 if you wish to drop a prior PGMS rendition
/* 
drop view pgms; delete from ctf where tc = 'PGMS'; delete from ctd where tc = 'PGMS';
*/
--########### SET OPTIONS IN THE NEXT TWO LINES TO BLOCK NSLP STATUS OR SPED INDICATION IN CUSTOM TABLE DEFINITION ###########
declare @HIDE_NSLP BIT = 1 --Specify 0 to unhide the NSLP column in the Custom Table definition. This leaves it available in SQL
declare @HIDE_SpEd BIT = 1 --Specify 0 to unhide the Special Ed column in the Custom Table definition. This leaves it available in SQL
--If you wish to block future updates because you customized this now, specify a date in the far distant future in the next line. Line 4 can override by dropping first.
declare @version varchar(23) = '2022-09-26 16:45:00.000'
--############################################################################################################################
set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'PGMS'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'PGMS'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale PGMS view of PGM involvement and Authorizations if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''PGMS''and o.[type_desc] = ''VIEW'') begin drop view PGMS end; delete from ctf where tc = ''PGMS''; delete from ctd where tc = ''PGMS'';'exec (@DynaQuery)
set @DynaQuery = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@DynaQuery)
set @DynaQuery = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@DynaQuery)
set @DynaQuery = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@DynaQuery)

set @DynaQuery = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))

update apds set jod = getdate()
update apds set jod = getdate()
'
EXEC (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
create view PGMS_descrip as 

WITH EFD --Most Recently Modified Effective Date from APDS.JOD (Just One Day)
(ID, JOD) as
(
SELECT ID, JOD FROM (
SELECT STU.ID, APDS.JOD
, ROW_NUMBER() OVER (PARTITION BY STU.ID ORDER BY STU.ID, STU.DTS DESC) RowNum
FROM STU INNER JOIN APDS 
ON STU.SC = APDS.SC AND STU.SN = APDS.SN 
WHERE APDS.DEL = 0 AND STU.DEL = 0
) D
WHERE RowNum = 1
)

select IDN.ID, 
isnull(
(select top 1 cd 
from fre 
where id = idn.id and esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed is null or eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')))
order by esd desc, sq desc)
,'''' ) as NSL,
isnull((select ''Y'' from cse where id = idn.id and di <> '''' and xd is null and del = 0),'''') SPD,
coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) EFD,
' 
select @DynaQuery += N'
case 
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (psd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (ped >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or ped is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Eligible''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and esd is null and psd is null and pid = idn.id and del = 0) then ''Null Start''
else ''''
end as ''PGM_'  + cd + N''' --PGM_CODE as Header
--end as '''  + left(de,128) + N''' --Description as Header
,' 
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') as de from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0 and ST = (select ST from loc where cd = 0)
union
select cd, replace(replace(de,'''',''''''),' ','_') as de from COD where tc = 'pgm' and fc = 'cd' and del = 0 and cd not in (select cd from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0)) codes where de not like '%no longer%' and de not like '%old code%' and cd <> ''

--and cd in ('122','131','135','190') --Even though this query builds an evaluation of all PGM codes with values, use this line to keep it simple and only select the codes you want
and cd in (select distinct pgm.cd from stu inner join pgm on stu.id = pgm.pid where stu.del = 0 
and (pgm.psd > CURRENT_TIMESTAMP - 2000 or pgm.esd > CURRENT_TIMESTAMP - 2000) --Only incude programs you still populate in a sensible timeframe.
and stu.tg = '' --remark this line out when evaluating historic programs no active students participate in
and pgm.cd <> '')


) PGMcodes order by cd

--Check to see if AUT codes are defined before attempting to run
if exists (select top 1 1 from (select cd, de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students
and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
)

begin --Transaction to evaluate AUT codes since they exist

select @DynaQuery += '
case 
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Conflict''
when idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''No''
else ''''
end as ''AUT_' + cd + ''' --AUT_CD  as header
,'
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students

--and cd in ('A','B') --Even though this query builds an evaluation of all AUT codes, use this line to keep it simple and only select the codes you want

and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
) AUTcodes order by cd

set @DynaQuery = left(@DynaQuery, len(@DynaQuery) - 1) -- remove the final comma  since we can't have a trailing comma before the FROM as there are no new dynamic columns

end --Transaction to evaluate AUT codes since they exist

set @DynaQuery = left(@DynaQuery, len(@DynaQuery) - 1) -- remove the final comma  since we can't have a trailing comma before the FROM as there are no new dynamic columns

select @DynaQuery += N'
,idn.del, idn.dts
from idn 
left join efd on idn.id = efd.id
where idn.del = 0

'

--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)


insert CTD (TC, NM, NLC, PKF, PT, PF, CF, OM, OB, VW)
select 'PGMS','Program and Authorization Status','Student Data','ID','STU','ID','ID','One','ID','1'

insert ctf (TC, FC, SQ, NM, TY, DL)
select 'PGMS' TC, COLUMN_NAME FC, row_number() over (order by ordinal_position ) * 2 -1 SQ,
case when COLUMN_NAME = 'ID' then 'PermID'
when COLUMN_NAME = 'NSL' then 'NSLP_Code'
when COLUMN_NAME = 'SPD' then 'Special_Ed'
when COLUMN_NAME = 'EFD' then 'Effective Date'
when left(COLUMN_NAME, 4) in ('PGM_','AUT_') then 
(select top 1 LEFT(DE,128)  from 
(select de from USYSGCOD where tc = left(COLUMN_NAME, 3) and fc = 'cd'  and cd = substring(COLUMN_NAME,charindex('_',COLUMN_NAME) + 1,255) and del = 0  and ST = (select ST from loc where cd = 0)
union
select de from COD where tc = left(COLUMN_NAME, 3) and fc = 'cd'  and cd = substring(COLUMN_NAME,charindex('_',COLUMN_NAME) + 1,255) and del = 0) codes)
else '' end NM,
case 
when right(DATA_TYPE, 3) like 'INT' then 'Number' 
when right(DATA_TYPE, 4) like 'CHAR' then 'Text'
else '' end TY, 
'600' DL
from INFORMATION_SCHEMA.columns 
where TABLE_NAME = 'pgms_descrip'
and COLUMN_NAME not in ('id','del','dts')
and COLUMN_NAME <> CASE WHEN @HIDE_NSLP = 1 THEN 'NSL' ELSE '' END
and COLUMN_NAME <> CASE WHEN @HIDE_SpEd = 1 THEN 'SPD' ELSE '' END


insert CTF (TC, FC, SQ)
select top (select count(*) - 1 from ctf where tc = 'PGMS') 
'PGMS' TC, FC = 'NEWLINE' + cast(row_number() over (order by sq) as varchar(4)),
sq + 1 SQ
from ctf where tc = 'PGMS'

drop view PGMS_Descrip


set @DynaQuery = N''

select @DynaQuery += N'
create view PGMS as 
--PGMS - Jared Kuszewski - Aeries Software - Version = ''' + @version + ''' 
--Remove Aeries Soft or make the version a far newer date in the line preceeding this if you wish to block updates by version control if you customize this view to your liking
WITH EFD --Most Recently Modified Effective Date from APDS.JOD (Just One Day)
(ID, JOD) as
(
SELECT ID, JOD FROM (
SELECT STU.ID, APDS.JOD
, ROW_NUMBER() OVER (PARTITION BY STU.ID ORDER BY STU.ID, STU.DTS DESC) RowNum
FROM STU INNER JOIN APDS 
ON STU.SC = APDS.SC AND STU.SN = APDS.SN 
WHERE APDS.DEL = 0 AND STU.DEL = 0
) D
WHERE RowNum = 1
)

select IDN.ID,  
isnull(
(select top 1 cd 
from fre 
where id = idn.id and esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed is null or eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')))
order by esd desc, sq desc)
,'''' ) as NSL,
isnull((select ''Y'' from cse where id = idn.id and di <> '''' and xd is null and del = 0),'''') SPD,
coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) EFD,
' 
select @DynaQuery += N'
case 
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (psd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (ped >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or ped is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and (esd <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Eligible''
when idn.id in (select pid from pgm where cd = ''' + CD + ''' and esd is null and psd is null and pid = idn.id and del = 0) then ''Null Start''
else ''''
end as ''P' + cast(ROW_NUMBER() over (order by cd) as varchar(3)) + N''' --PGM code Header
,' 
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') as de from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0 and ST = (select ST from loc where cd = 0)
union
select cd, replace(replace(de,'''',''''''),' ','_') as de from COD where tc = 'pgm' and fc = 'cd' and del = 0 and cd not in (select cd from USYSGCOD where tc = 'pgm' and fc = 'cd' and del = 0 and ST = (select ST from loc where cd = 0))) codes where de not like '%no longer%' and de not like '%old code%' and cd <> ''

--and cd in ('122','131','135','190') --Even though this query builds an evaluation of all PGM codes with values, use this line to keep it simple and only select the codes you want
and cd in (select distinct pgm.cd from stu inner join pgm on stu.id = pgm.pid where stu.del = 0 
and (pgm.psd > CURRENT_TIMESTAMP - 2000 or pgm.esd > CURRENT_TIMESTAMP - 2000) --Only incude programs you still populate in a sensible timeframe.
and stu.tg = '' --remark this line out when evaluating historic programs no active students participate in
and pgm.cd <> '')


) PGMcodes order by cd

--Check to see if AUT codes are defined before attempting to run
if exists (select top 1 1 from (select cd, de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students
and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
)

begin --Transaction to evaluate AUT codes since they exist

select @DynaQuery += '
case 
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Yes''
when idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''Conflict''
when idn.id not in (select pid from aut where cd = ''' + CD + ''' and st = ''1'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) and idn.id in (select pid from aut where cd = ''' + CD + ''' and st = ''2'' and (dt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) and (sdt <= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or sdt is null) and (eed >= coalesce(EFD.JOD,format(getdate(),''MM/dd/yyyy'')) or eed is null)) and pid = idn.id and del = 0) then ''No''
else ''''
end as [A' + cast(ROW_NUMBER() over (order by cd) as varchar(3)) + '] --AUT code header
,'
from (select cd, de from (select cd, replace(replace(de,'''',''''''),' ','_') de from COD where tc = 'aut' and fc = 'cd' and del = 0) codes where cd <> ''
and cd in (select distinct cd from aut where del = 0 and pid in (select distinct id from stu where del = 0 and tg = '')) --Just AUT codes on active students

--and cd in ('A','B') --Even though this query builds an evaluation of all AUT codes, use this line to keep it simple and only select the codes you want

and cd in (select distinct cd from aut where del = 0) --just select AUT codes being used
) AUTcodes order by cd

end --Transaction to evaluate AUT codes since they exist

set @DynaQuery = left(@DynaQuery, len(@DynaQuery) - 1) -- remove the final comma  since we can't have a trailing comma before the FROM as there are no new dynamic columns

select @DynaQuery += N'
,idn.del, idn.dts
from idn 
left join efd on idn.id = efd.id
where idn.del = 0

'

--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)

update CTF
set FC = NEWFC
from ctf inner join (select sq, 
case when fc like 'PGM_%' then 'P' + cast(ROW_NUMBER() over (order by sq) as varchar(3)) end NEWFC
from ctf
where tc = 'pgms' and fc like 'PGM_%') c
on ctf.sq = c.sq
where tc = 'pgms' and fc like 'PGM_%'

update CTF
set FC = NEWFC
from ctf inner join (select sq, 
case when fc like 'AUT_%' then 'A' + cast(ROW_NUMBER() over (order by sq) as varchar(3)) end NEWFC
from ctf
where tc = 'pgms' and fc like 'AUT_%') c
on ctf.sq = c.sq
where tc = 'pgms' and fc like 'AUT_%'

update ctf set TY = 'Date' where tc = 'PGMS' and FC = 'EFD'

print 'PGMS Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of PGMS blocked by version control - PGMS needs no update or was customized'
set nocount off
GO

--SMSP - Classes pivoted for the current or custom day in APDS.JOD - Custom View - Aeries Software - Jared Kuszewski
--So if students attend different classes each day or you use A/B day scheduling. Just use this on a similar dayof the week.
--Create SMSP Custom View if not present - Run line 5 if you wish to drop a prior SMSP rendition before I added version control
/* 
drop view SMSP; delete from ctf where tc = 'SMSP'; delete from ctd where tc = 'SMSP';drop table APDS; delete from ctf where tc = 'APDS'; delete from ctd where tc = 'APDS';
*/
declare @version varchar(23) = '2022-09-26 16:45:00.000' --Specify a date in the distant future like 2199-01-01 to block revisions if you have customized this

set nocount on
if exists ((select top 1 1
from sys.objects o inner join sys.sql_modules m
on o.object_id = m.object_id
where o.[name] = 'SMSP'
and o.[type_desc] in ('VIEW')
and m.definition like ('%Aeries Software%')
and cast(@version as datetime) > 
case when isdate(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23)) = 1 
then cast(substring(m.[definition],charindex('Version = ',m.[definition])+11, 23) as datetime) 
else '1900-1-1' end)
union (select 1 where (select top 1 1 from sys.objects o where o.[name] = 'SMSP'and o.[type_desc] = 'VIEW') is null))
BEGIN
--Drop Stale SMSP view if stale and recreate it
declare @DynaQuery nvarchar(max) = 'if exists (select top 1 1 from sys.objects o where o.[name] = ''SMSP''and o.[type_desc] = ''VIEW'') begin drop view SMSP end; delete from ctf where tc = ''SMSP''; delete from ctd where tc = ''SMSP'';'
exec (@DynaQuery)
set @DynaQuery = N'if exists (select top 1 1 from sys.objects o where o.[name] = ''APDS''and o.[type_desc] = ''USER_TABLE'') begin drop table APDS; delete from ctf where tc = ''APDS''; delete from ctd where tc = ''APDS''; end' exec (@DynaQuery)
set @DynaQuery = N'
CREATE TABLE [dbo].[APDS](
	[SC] [smallint] NOT NULL default 0,
	[SN] [int] NOT NULL default 0,
	[NTS] [varchar](1000) NOT NULL,
	[SWH] [datetime] NULL,
	[TWH] [datetime] NULL,
	[JOD] [datetime] NULL,
	[DEL] [bit] NOT NULL,
	[DTS] [datetime] NULL,
 CONSTRAINT [PK_APDS] PRIMARY KEY CLUSTERED 
(
	[SC] ASC,
	[SN] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_NTS]  DEFAULT (''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.'')

 FOR [NTS]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ADD  CONSTRAINT [DF_APDS_DEL]  DEFAULT ((0)) FOR [DEL]
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS]  WITH CHECK ADD  CONSTRAINT [FK_APDS_STU] FOREIGN KEY([SC], [SN])
REFERENCES [dbo].[STU] ([SC], [SN])
ON UPDATE CASCADE
ON DELETE CASCADE
' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] CHECK CONSTRAINT [FK_APDS_STU]
' exec(@DynaQuery)
set @DynaQuery = N'

/****** Object:  Trigger dbo.APDS_update_DTS    Script Date: 4/1/2003 8:45:18 AM ******/
CREATE TRIGGER [dbo].[APDS_update_DTS] ON [dbo].[APDS] FOR UPDATE, INSERT AS

if getdate() > isnull((select top 1 dt from log with (nolock) order by tid),''12/31/9999'') + 1 --Only Work a day after rollover
begin
if (select count(*) from stu with (nolock)) > (select count(*) from apds with (nolock)) --Only run if APDS rows are actually needed
begin
IF EXISTS(SELECT INSERTED.DTS, DELETED.DTS FROM INSERTED, DELETED WHERE INSERTED.DTS=DELETED.DTS) OR (NOT EXISTS(SELECT DELETED.DTS FROM DELETED) AND EXISTS(SELECT INSERTED.DTS FROM INSERTED WHERE INSERTED.DTS IS NULL)) UPDATE APDS SET APDS.DTS = GetDate() FROM APDS, INSERTED WHERE APDS.SC = INSERTED.SC AND APDS.SN = INSERTED.SN

INSERT APDS (SC, SN, DEL, DTS)
SELECT STU.SC, STU.SN, 0, GETDATE()
FROM STU LEFT JOIN APDS ON
STU.SC = APDS.SC AND STU.SN = APDS.SN
WHERE APDS.SN IS NULL

end

UPDATE APDS SET NTS = ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''
WHERE NTS <> ''This form allows you to specify a date range that will be used by a view such as ''''Attendance Percentage by Date Range'''' and ''''Just One Day'''' for others.''

--Restore deleted row if that happened
update apds 
set del = stu.del
from apds inner join stu
on apds.sc = stu.sc and apds.sn = stu.sn
where apds.del <> stu.del
end


' exec(@DynaQuery)
set @DynaQuery = N'

ALTER TABLE [dbo].[APDS] ENABLE TRIGGER [APDS_update_DTS]
' exec(@DynaQuery)

set @DynaQuery = N'
INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N''APDS'', N''Attendance Percentage by Date Settings'', N''Student Data'', N''SC,SN'', N''STU'', N''SC,SN'', N''SC,SN'', N''One'', N'''', 0, CAST(N''2019-09-22T22:15:28.047'' AS DateTime), 0)
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NTS'', 1, N''Note'', N''Text'', 600, 0, 0, 0, CAST(N''2019-09-22T22:28:40.013'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''NEWLINE1'', 2, N'''', N'''', 0, 0, 0, 0, CAST(N''2019-09-22T22:28:29.050'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''SWH'', 3, N''Since When (Beginning Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:10.060'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''TWH'', 4, N''Until When (Ending Date Range)'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N''APDS'', N''JOD'', 5, N''Just One Day'', N''Date'', 300, 0, 0, 0, CAST(N''2019-09-22T22:29:40.983'' AS DateTime))
'
EXEC (@DynaQuery)
set @DynaQuery = N''
select @DynaQuery += N'
--SMSP - Classes pivoted for the current Day - Custom View - Jared Kuszewski - Aeries Software - Version = ''' + @version + '''
Create View [dbo].[SMSP] as

WITH TDAYS (SC, DY, DT, AB, BL, Track, HO)
as (
select SC, DY, DT, AB, BL, left(TrackHO,1) Track, substring(TrackHO,2,1) as HO
from
(
select SC, DY, DT, AB, HO, BL,TrackHO
from
(SELECT        SC, DY, DT, AB, HO, BL,
''A''+T1 as T1, 
''B''+T2 as T2, 
''C''+T3 as T3, 
''D''+T4 as T4, 
''E''+T5 as T5, 
''F''+T6 as T6, 
''G''+T7 as T7, 
''H''+T8 as T8, 
''I''+T9 as T9, 
''J''+T10 as T10, 
''K''+T11 as T11, 
''L''+T12 as T12, 
''M''+T13 as T13, 
''N''+T14 as T14, 
''O''+T15 as T15, 
''P''+T16 as T16, 
''Q''+T17 as T17, 
''R''+T18 as T18, 
''S''+T19 as T19, 
''T''+T20 as T20, 
''U''+T21 as T21, 
''V''+T22 as T22, 
''W''+T23 as T23, 
''X''+T24 as T24, 
''Y''+T25 as T25, 
''Z''+T26 as T26
from day WHERE DEL = 0) pvt
unpivot
( TrackHO for Tracks in (T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23, T24, T25, T26)) as unpiv
where ascii(left(TrackHO,1)) between 64 and (64 + (select k from loc where del = 0 and cd = unpiv.sc))
union 
select SC, DY, DT, AB, HO, BL, '' '' + HO AS TrackHO from day where DEL = 0
) trackdays
)

--The SMS Class Pivot

SELECT SC, SN
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN SM END),'''') SM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(PD AS VARCHAR(6)) END),'''') PD1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(se AS VARCHAR(5)) END),'''') SE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(TE AS VARCHAR(500)) END),'''') TE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN RM END),'''') RM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CN END),'''') CN1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CO END),'''') CO1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN DE END),'''') DE1

,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN SM END),'''') SM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(PD AS VARCHAR(6)) END),'''') PD2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(se AS VARCHAR(5)) END),'''') SE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(TE AS VARCHAR(500)) END),'''') TE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN RM END),'''') RM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CN END),'''') CN2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CO END),'''') CO2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN DE END),'''') DE2

,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN SM END),'''') SM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(PD AS VARCHAR(6)) END),'''') PD3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(se AS VARCHAR(5)) END),'''') SE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(TE AS VARCHAR(500)) END),'''') TE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN RM END),'''') RM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CN END),'''') CN3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CO END),'''') CO3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN DE END),'''') DE3

,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN SM END),'''') SM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(PD AS VARCHAR(6)) END),'''') PD4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(se AS VARCHAR(5)) END),'''') SE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(TE AS VARCHAR(500)) END),'''') TE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN RM END),'''') RM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CN END),'''') CN4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CO END),'''') CO4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN DE END),'''') DE4

,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN SM END),'''') SM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(PD AS VARCHAR(6)) END),'''') PD5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(se AS VARCHAR(5)) END),'''') SE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(TE AS VARCHAR(500)) END),'''') TE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN RM END),'''') RM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CN END),'''') CN5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CO END),'''') CO5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN DE END),'''') DE5

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN SM END),'''') SM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(PD AS VARCHAR(6)) END),'''') PD6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(se AS VARCHAR(5)) END),'''') SE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(TE AS VARCHAR(500)) END),'''') TE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN RM END),'''') RM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CN END),'''') CN6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CO END),'''') CO6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN DE END),'''') DE6

,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN SM END),'''') SM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(PD AS VARCHAR(6)) END),'''') PD7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(se AS VARCHAR(5)) END),'''') SE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(TE AS VARCHAR(500)) END),'''') TE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN RM END),'''') RM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CN END),'''') CN7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CO END),'''') CO7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN DE END),'''') DE7

,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN SM END),'''') SM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(PD AS VARCHAR(6)) END),'''') PD8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(se AS VARCHAR(5)) END),'''') SE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(TE AS VARCHAR(500)) END),'''') TE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN RM END),'''') RM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CN END),'''') CN8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CO END),'''') CO8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN DE END),'''') DE8

,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN SM END),'''') SM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(PD AS VARCHAR(6)) END),'''') PD9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(se AS VARCHAR(5)) END),'''') SE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(TE AS VARCHAR(500)) END),'''') TE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN RM END),'''') RM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CN END),'''') CN9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CO END),'''') CO9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN DE END),'''') DE9

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN SM END),'''') SM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(PD AS VARCHAR(6)) END),'''') PD10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(se AS VARCHAR(5)) END),'''') SE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(TE AS VARCHAR(500)) END),'''') TE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN RM END),'''') RM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CN END),'''') CN10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CO END),'''') CO10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN DE END),'''') DE10
,0 DEL
,GETDATE() DTS

FROM (
SELECT STU.SC, STU.SN, SMS.SM, SMS.PD, SMS.SE, TCH.TE, SMS.RM, CRS.CN, CRS.CO, CRS.DE,
ROW_NUMBER () OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, SMS.PD, SMS.SE) ClassOrder
FROM
STU 
LEFT JOIN SSS ON STU.SC = SSS.SC AND STU.SN = SSS.SN AND SSS.DEL = 0
LEFT JOIN SMS ON SSS.SC = SMS.SC  AND SSS.SE = SMS.SE AND SMS.DEL = 0
LEFT JOIN CRS ON SMS.CN = CRS.CN AND CRS.DEL = 0
LEFT JOIN TCH ON SMS.SC = TCH.SC AND SMS.TN = TCH.TN AND TCH.DEL = 0
WHERE STU.DEL = 0
AND STU.SC NOT IN (SELECT CD FROM LOC WHERE DEL = 0 AND E = ''3'')
AND (SMS.SM IS NULL OR SMS.SM 
IN (SELECT TM FROM TRM 
WHERE CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END BETWEEN D1 AND D2)) --ONLY CURRENT TERMS
AND STU.SC IN (SELECT CD FROM LOC WHERE E in (0,2) AND DEL = 0 AND TG = '''') --Just master schedule schools
AND 1 = CASE 
WHEN SMS.DY = ''A-DAYS'' AND 
CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END
= (SELECT DT FROM TDAYS WHERE SC = STU.SC AND Track = STU.TR AND AB = ''A'' AND BL LIKE (''%'' + CAST(SMS.PD AS VARCHAR(1)) + ''%'') AND DT 
= CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END) THEN 1
WHEN SMS.DY = ''B-DAYS'' AND 
CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END
= (SELECT DT FROM TDAYS WHERE SC = STU.SC AND Track = STU.TR AND AB = ''B'' AND BL LIKE (''%'' + CAST(SMS.PD AS VARCHAR(1)) + ''%'') AND DT 
= CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE CAST(GETDATE() AS DATE) END) THEN 1
WHEN SMS.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 2 AND SMS.MM = 1 THEN 1
WHEN SMS.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 3 AND SMS.MT = 1 THEN 1
WHEN SMS.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 4 AND SMS.MW = 1 THEN 1
WHEN SMS.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 5 AND SMS.MR = 1 THEN 1
WHEN SMS.DY NOT IN (''A-DAYS'',''B-DAYS'') AND DATEPART(DW, CASE WHEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN)  IS NOT NULL THEN (SELECT JOD FROM APDS WHERE DEL = 0 AND SC = STU.SC AND SN = STU.SN) ELSE GETDATE() END) = 6 AND SMS.MF = 1 THEN 1
ELSE 0
END
) Classes

GROUP BY SC, SN


union all

'
select @DynaQuery += N'
--The SMS Class Pivot FLEX
SELECT SC, SN
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN SM END),'''') SM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(PD AS VARCHAR(6)) END),'''') PD1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(se AS VARCHAR(5)) END),'''') SE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CAST(TE AS VARCHAR(500)) END),'''') TE1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN RM END),'''') RM1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CN END),'''') CN1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN CO END),'''') CO1
,ISNULL(MAX(CASE WHEN ClassOrder = 1 THEN DE END),'''') DE1

,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN SM END),'''') SM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(PD AS VARCHAR(6)) END),'''') PD2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(se AS VARCHAR(5)) END),'''') SE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CAST(TE AS VARCHAR(500)) END),'''') TE2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN RM END),'''') RM2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CN END),'''') CN2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN CO END),'''') CO2
,ISNULL(MAX(CASE WHEN ClassOrder = 2 THEN DE END),'''') DE2

,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN SM END),'''') SM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(PD AS VARCHAR(6)) END),'''') PD3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(se AS VARCHAR(5)) END),'''') SE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CAST(TE AS VARCHAR(500)) END),'''') TE3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN RM END),'''') RM3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CN END),'''') CN3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN CO END),'''') CO3
,ISNULL(MAX(CASE WHEN ClassOrder = 3 THEN DE END),'''') DE3

,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN SM END),'''') SM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(PD AS VARCHAR(6)) END),'''') PD4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(se AS VARCHAR(5)) END),'''') SE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CAST(TE AS VARCHAR(500)) END),'''') TE4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN RM END),'''') RM4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CN END),'''') CN4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN CO END),'''') CO4
,ISNULL(MAX(CASE WHEN ClassOrder = 4 THEN DE END),'''') DE4

,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN SM END),'''') SM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(PD AS VARCHAR(6)) END),'''') PD5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(se AS VARCHAR(5)) END),'''') SE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CAST(TE AS VARCHAR(500)) END),'''') TE5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN RM END),'''') RM5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CN END),'''') CN5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN CO END),'''') CO5
,ISNULL(MAX(CASE WHEN ClassOrder = 5 THEN DE END),'''') DE5

'
select @DynaQuery += N'
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN SM END),'''') SM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(PD AS VARCHAR(6)) END),'''') PD6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(se AS VARCHAR(5)) END),'''') SE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CAST(TE AS VARCHAR(500)) END),'''') TE6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN RM END),'''') RM6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CN END),'''') CN6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN CO END),'''') CO6
,ISNULL(MAX(CASE WHEN ClassOrder = 6 THEN DE END),'''') DE6

,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN SM END),'''') SM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(PD AS VARCHAR(6)) END),'''') PD7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(se AS VARCHAR(5)) END),'''') SE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CAST(TE AS VARCHAR(500)) END),'''') TE7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN RM END),'''') RM7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CN END),'''') CN7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN CO END),'''') CO7
,ISNULL(MAX(CASE WHEN ClassOrder = 7 THEN DE END),'''') DE7

,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN SM END),'''') SM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(PD AS VARCHAR(6)) END),'''') PD8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(se AS VARCHAR(5)) END),'''') SE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CAST(TE AS VARCHAR(500)) END),'''') TE8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN RM END),'''') RM8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CN END),'''') CN8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN CO END),'''') CO8
,ISNULL(MAX(CASE WHEN ClassOrder = 8 THEN DE END),'''') DE8

,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN SM END),'''') SM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(PD AS VARCHAR(6)) END),'''') PD9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(se AS VARCHAR(5)) END),'''') SE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CAST(TE AS VARCHAR(500)) END),'''') TE9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN RM END),'''') RM9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CN END),'''') CN9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN CO END),'''') CO9
,ISNULL(MAX(CASE WHEN ClassOrder = 9 THEN DE END),'''') DE9

,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN SM END),'''') SM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(PD AS VARCHAR(6)) END),'''') PD10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(se AS VARCHAR(5)) END),'''') SE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CAST(TE AS VARCHAR(500)) END),'''') TE10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN RM END),'''') RM10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CN END),'''') CN10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN CO END),'''') CO10
,ISNULL(MAX(CASE WHEN ClassOrder = 10 THEN DE END),'''') DE10
,0 DEL
,GETDATE() DTS

'
select @DynaQuery += N'

FROM (
SELECT 
STU.SC, STU.SN, SMS.SM, FTF.STI PD, SMS.SE, 
STUFF(
(SELECT  '' | '',STF.FN + '' '' + STF.LN
FROM SSE 
INNER JOIN STF ON SSE.ID = STF.ID
WHERE SSE.DEL = 0 AND STF.DEL = 0 AND SSE.TG = '''' 
AND COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy'')) BETWEEN
COALESCE(SD,''1/1/1900'')
AND
COALESCE(ED,''12/31/9999'')
AND SSE.SC = SMS.SC AND SSE.SE = SMS.SE
ORDER BY PR DESC, SD
FOR XML PATH (''''))
, 1, 3, '''') TE
, SMS.RM, CRS.CN, CRS.CO, CRS.DE,
ROW_NUMBER () OVER (PARTITION BY STU.SC, STU.SN ORDER BY STU.SC, STU.SN, CAST(FORMAT(FTF.ST,''HH:mm:ss'') AS DATETIME), SMS.SE) ClassOrder
FROM
(SELECT SC, SN, ID, TR FROM STU WHERE DEL = 0) STU
INNER JOIN (SELECT * FROM CAR WHERE DEL = 0) CAR ON STU.SC = CAR.SC AND STU.SN = CAR.SN
LEFT JOIN (SELECT * FROM CRS WHERE DEL = 0) CRS ON CAR.CN = CRS.CN
INNER JOIN (SELECT * FROM TDAYS WHERE DT < GETDATE() AND HO NOT IN (''@'',''#'',''$'',''*'')) TDAYS ON TDAYS.SC = STU.SC AND TDAYS.Track = STU.TR
LEFT JOIN (SELECT * FROM SMS WHERE DEL = 0) SMS ON SMS.SC = CAR.SC AND SMS.SE = CAR.SE
INNER JOIN (SELECT * FROM CCD WHERE DEL = 0) CCD ON SMS.CSQ = CCD.CSQ AND CCD.DT = TDAYS.DT
INNER JOIN (SELECT * FROM FTF WHERE DEL = 0) FTF ON SMS.FSQ = FTF.SQ
LEFT JOIN (SELECT * FROM APDS WHERE DEL = 0) APDS ON APDS.SC = STU.SC AND APDS.SN = STU.SN 
WHERE STU.SC IN (SELECT CD FROM LOC WHERE DEL = 0 AND E = ''3'')
AND COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy'')) BETWEEN CAR.DS AND CAR.DE --ONLY CURRENT TERMS
AND CCD.DT = COALESCE(APDS.JOD,FORMAT(GETDATE(),''MM/dd/yyyy''))
) Classes

GROUP BY SC, SN

'

--print @DynaQuery --NOTE: Print truncates at NVARCHAR(4000) characters
exec (@DynaQuery)


INSERT [dbo].[CTD] ([TC], [NM], [NLC], [PKF], [PT], [PF], [CF], [OM], [OB], [DEL], [DTS], [VW]) VALUES (N'SMSP', N'SMS Classes Pivoted', N'', N'SC,SN', N'STU', N'SC,SN', N'SC,SN', N'One', N'SC,SN,SM,PD,SE', 0, CAST(N'2019-03-01T22:18:43.317' AS DateTime), 1)

INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM1', 1, N'Class 1 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:40.707' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD1', 2, N'Class 1 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:51.777' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE1', 3, N'Class 1 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:22:59.387' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE1', 4, N'Class 1 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:06.940' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM1', 5, N'Class 1 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:12.173' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN1', 6, N'Class 1 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:08.750' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO1', 7, N'Class 1 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:24.983' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE1', 8, N'Class 1 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:23:49.463' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM2', 9, N'Class 2 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:16.713' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD2', 10, N'Class 2 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:19.830' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE2', 11, N'Class 2 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:32.807' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE2', 12, N'Class 2 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:37.713' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM2', 13, N'Class 2 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:24:52.757' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN2', 14, N'Class 2 Couse ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:03.830' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO2', 15, N'Class 2 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:19.397' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE2', 16, N'Class 2 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:40.903' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM3', 17, N'Class 3 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:27:18.273' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD3', 18, N'Class 3 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:47.107' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE3', 19, N'Class 3 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:48.517' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE3', 20, N'Class 3 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:48.933' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM3', 21, N'Class 3 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:53.630' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN3', 22, N'Class 3 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:25.550' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO3', 23, N'Class 3 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:15.153' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE3', 24, N'Class 3 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:25:53.013' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM4', 25, N'Class 4 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:01.997' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD4', 26, N'Class 4 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:57.170' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE4', 27, N'Class 4 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:53.873' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE4', 28, N'Class 4 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:57.817' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM4', 29, N'Class 4 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:01.507' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN4', 30, N'Class 4 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:32.173' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO4', 31, N'Class 4 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:21.283' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE4', 32, N'Class 4 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:05.837' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM5', 33, N'Class 5 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:43.047' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD5', 34, N'Class 5 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:45.950' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE5', 35, N'Class 5 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:02.743' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE5', 36, N'Class 5 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:04.707' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM5', 37, N'Class 5 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:06.320' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN5', 38, N'Class 5 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:38.940' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO5', 39, N'Class 5 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:27.043' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE5', 40, N'Class 5 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:11.390' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM6', 41, N'Class 6 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:32.273' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD6', 42, N'Class 6 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:29:36.037' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE6', 43, N'Class 6 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:07.673' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE6', 44, N'Class 6 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:10.240' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM6', 45, N'Class 6 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:15.553' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN6', 46, N'Class 6 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:45.043' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO6', 47, N'Class 6 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:34.550' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE6', 48, N'Class 6 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:21.053' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM7', 49, N'Class 7 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:27:47.813' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD7', 50, N'Class 7 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:11.100' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE7', 51, N'Class 7 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:13.237' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE7', 52, N'Class 7 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:15.607' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM7', 53, N'Class 7 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:22.763' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN7', 54, N'Class 7 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:52.933' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO7', 55, N'Class 7 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:40.650' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE7', 56, N'Class 7 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:30.680' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM8', 57, N'Class 8 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:15.660' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD8', 58, N'Class 8 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:17.790' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE8', 59, N'Class 8 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:20.510' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE8', 60, N'Class 8 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:21.360' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM8', 61, N'Class 8 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:28.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN8', 62, N'Class 8 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:58.493' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO8', 63, N'Class 8 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:36:50.050' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE8', 64, N'Class 8 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:37.967' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM9', 65, N'Class 9 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:10.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD9', 66, N'Class 9 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:25.740' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE9', 67, N'Class 9 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:26.683' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE9', 68, N'Class 9 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:26.680' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM9', 69, N'Class 9 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:33:59.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN9', 70, N'Class 9 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:35:03.623' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO9', 71, N'Class 9 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:37:00.957' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE9', 72, N'Class 9 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:45.353' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SM10', 73, N'Class 10 Term', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:28:34.657' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'PD10', 74, N'Class 10 Period', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:30:32.300' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'SE10', 75, N'Class 10 SSStion', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:31:32.407' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'TE10', 76, N'Class 10 Teacher', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:32:31.787' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'RM10', 77, N'Class 10 Room', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:34:06.160' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CN10', 78, N'Class 10 Course ID', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:35:08.913' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'CO10', 79, N'Class 10 Course Title', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:37:07.783' AS DateTime))
INSERT [dbo].[CTF] ([TC], [FC], [SQ], [NM], [TY], [DL], [ML], [DS], [DEL], [DTS]) VALUES (N'SMSP', N'DE10', 80, N'Class 10 Course Description', N'Text', 300, 0, 0, 0, CAST(N'2019-03-01T22:26:52.823' AS DateTime))

update apds set jod = getdate()
update apds set jod = getdate()

print 'SMSP Custom View Created or Refreshed!'
set nocount off
END

else print 'Update of SMSP blocked by version control - SMSP needs no update or was customized.'
set nocount off
GO
